
function Item(index, name, value, code){
    this.index = index;
    this.name = name;
	this.value = value;
	this.code = code;
	this.colour = '';
	this.x1 = 0;
	this.y1 = 0;
	this.x2 = 0;
	this.y2 = 0;
 }
 
function FieldItem(index, name, type){
    this.index = index;
    this.name = name;
	this.type = type;
 } 
 
function DataItem(index, value){
    this.index = index;
    this.value = value;
}  
 
 function round(value, decimals) {
  return Number(Math.round(value+'e'+decimals)+'e-'+decimals);
}
 
 function addItem(index, name, value) {
	Inventory[index] = new Item();
	Inventory[index].name = name;
	Inventory[index].value = value;
 }

function pastelColors(){
    var r = (Math.round(Math.random()* 127) + 127).toString(16);
    var g = (Math.round(Math.random()* 127) + 127).toString(16);
    var b = (Math.round(Math.random()* 127) + 127).toString(16);
    return '#' + r + g + b;
} 
 
 function draw(idx,idxc) {
	var items = Inventory[idx].data.length;
	var divrel = document.getElementById(idx),
		elem = document.getElementById(idxc),
		context = elem.getContext("2d"),
		elemLeft = elem.clientLeft + divrel.clientLeft,
		elemTop =  elem.clientTop + divrel.clientTop,
		elements = [];
	var coorX = 90, wBorder = true;    
	
	elem.width = document.getElementById(idx).offsetWidth - 5;
	elem.height = document.getElementById(idx).offsetHeight - 5;
		
	var space = 0, valor = 0, anchor = 0, pos = coorX, sep = 8, hue, longo, myMax =0,
		myTotal = 0, longitud = 0;
	var posx = 0, posy = 0, lastend = 0;		

	switch(Inventory[idx].type) {
	case 1:
		space = elem.width - 4 - (coorX + 35);
		longitud = elem.height - 40;
		break;
	case 4:
		wBorder = false;
		coorX += 5;
		longitud =  elem.width - 4 - (coorX + 35);
		space = elem.height - 40;	
		break;		
	case 3:
	case 2:
		coorX += 5;
		longitud =  elem.width - 4 - (coorX + 35);
		space = elem.height - 50;	
		break;
	}
		
	// Limpiar canvas
	context.fillStyle = '#fff';
	context.fillRect(0, 0, elem.width, elem.height);
	
	// Agregar evento de clic
	elem.addEventListener('click', function(event) {
		
		var x = parseInt(event.clientX-$(this).offset().left);
		var y = parseInt(event.clientY-$(this).offset().top);
	  		
		for (i = 0; i < items; i++) {
			console.log('x='+x+ '; x1='+Inventory[idx].data[i].x1+'; x2='+(Inventory[idx].data[i].x1+Inventory[idx].data[i].x2));
			if ((Inventory[idx].data[i].x1 <= x) && 
				((Inventory[idx].data[i].x1 +Inventory[idx].data[i].x2) >= x) &&
				(Inventory[idx].data[i].y1 <= y) &&
				((Inventory[idx].data[i].y1 +Inventory[idx].data[i].y2) >= y)) {
				alert('Click on: ' + Inventory[idx].data[i].code);
				break;
			}
		}
	}, false);	

	// Tamaño de columnas
	anchor = (longitud - (items*sep)) / items; 

	// Dibujar el eje X y Y
	if (wBorder == true) {
		context.beginPath();
		context.lineWidth = 1;
		context.strokeStyle = "#bbbbbb";
		context.lineCap="round";
		context.moveTo(pos - 1, 20);
		context.lineTo(pos - 1, elem.height - 30);
		context.lineTo(pos - 1 + elem.width - 4 - (pos + 35), elem.height - 30);
		context.stroke();	
	}

	// Calcula el valor mas alto entre los valores dados
	for (i =0; i < items; i++) {
		if (Inventory[idx].data[i].value > myMax) {
			myMax = Inventory[idx].data[i].value;			
		}
		myTotal += Inventory[idx].data[i].value;
	}
	
	switch(Inventory[idx].type) {
	case 1:
		pos = 20;		
		break;
	case 4:
		posx = coorX + (longitud * 0.25);
		posy = 20 + (space/2);	
		lastend = 0;
		anchor = (space - (items*sep)) / items; 		
		pos  = 20;		
		break;
	case 3:
	case 2:
		pos  = coorX;		
		break;
	}
	
	// Recorre los objetos 
	for (i =0; i < items; i++) {
		valor = (Inventory[idx].data[i].value*100)/myMax;
		//hue = Math.floor(Math.random() * 360);
		longo = (space*(valor/110));		
		Inventory[idx].data[i].colour = '#539fd8'; 

		switch (Inventory[idx].type) {
		case 1:
			// Barras verticales
			Inventory[idx].data[i].x1 = coorX;
			Inventory[idx].data[i].y1 = pos;
			Inventory[idx].data[i].x2 = longo;
			Inventory[idx].data[i].y2 = anchor;
		
			context.fillStyle = Inventory[idx].data[i].colour;
			context.fillRect(Inventory[idx].data[i].x1, 
				Inventory[idx].data[i].y1, 
				Inventory[idx].data[i].x2, 
				Inventory[idx].data[i].y2);
			
			context.font = 'bold 12pt Calibri';
			context.fillStyle = '#000';
			context.textAlign="start"; 
			context.fillText(Inventory[idx].data[i].value, longo + coorX + 2, pos + ((anchor+sep)/2));
			context.textAlign="end"; 
			context.fillStyle = '#000';
			context.fillText(Inventory[idx].data[i].name, coorX-3, pos + ((anchor+sep)/2));
			
			break;
		case 2:
			// Lineas
			Inventory[idx].data[i].x1 = pos + ((anchor+sep)/2); // coorX;
			Inventory[idx].data[i].y1 = space - 	longo;
			Inventory[idx].data[i].x2 = pos + ((anchor+sep)/2); //coorX + longo;
			Inventory[idx].data[i].y2 = space + 4; //pos + anchor;
		
			context.beginPath();
			context.arc(Inventory[idx].data[i].x1, Inventory[idx].data[i].y1, 3, 0*Math.PI, 2*Math.PI);
			context.fillStyle = "#539fd8";
			context.fill();
		
			if (i > 0) {
				context.beginPath();
				context.strokeStyle = "#539fd8";
				context.moveTo(Inventory[idx].data[i-1].x1,Inventory[idx].data[i-1].y1);
				context.lineTo(Inventory[idx].data[i].x1,Inventory[idx].data[i].y1);
				context.stroke();				
			}
			
			context.font = 'bold 12pt Calibri';
			context.fillStyle = '#000';
			context.textAlign="start"; 
			context.fillText(Inventory[idx].data[i].value, pos + ((anchor+sep)/2), space - longo - 10);
			context.textAlign="center"; 
			context.fillStyle = '#000';
			context.fillText(Inventory[idx].data[i].name, pos + ((anchor+sep)/2), space + 40);
			
			break;
		case 3:
			// Barras 2d
			Inventory[idx].data[i].x1 = pos;
			Inventory[idx].data[i].y1 = 20 + space - longo;
			Inventory[idx].data[i].x2 = anchor; 
			Inventory[idx].data[i].y2 = longo; 		
		
			context.fillStyle = Inventory[idx].data[i].colour;
			context.fillRect(Inventory[idx].data[i].x1, Inventory[idx].data[i].y1, 
				Inventory[idx].data[i].x2, Inventory[idx].data[i].y2);
			
			context.font = 'bold 12pt Calibri';
			context.fillStyle = '#000';
			context.textAlign="start"; 
			context.fillText(Inventory[idx].data[i].value, pos + ((anchor+sep)/2), 20 + space - longo - 10);
			context.textAlign="center"; 
			context.fillStyle = '#000';
			context.fillText(Inventory[idx].data[i].name, pos + ((anchor+sep)/2), space + 40);
			
			break;	
		case 4:
			// Pie
			
			if (Inventory[idx].data[i].colour != '') 
				Inventory[idx].data[i].colour = pastelColors();
			
			Inventory[idx].data[i].x1 = coorX + (longitud/2);
			Inventory[idx].data[i].y1 = pos;
			Inventory[idx].data[i].x2 = 10; 
			Inventory[idx].data[i].y2 = 10; 		
			
			var slice_angle = round((Math.PI * 2 * (Inventory[idx].data[i].value / myTotal)),2);
			
			context.fillStyle = Inventory[idx].data[i].colour;
			context.beginPath();
			context.moveTo(posx, posy);
			// Arc Parameters: x, y, radius, startingAngle (radians), endingAngle (radians), antiClockwise (boolean)
			context.arc(posx, posy, (posy*0.66), lastend, lastend + slice_angle, false);
			context.lineTo(posx, posy);
			context.fill();	
			
			var pieRadius = Math.min(posx,posy); 
			var labelX = posx + (pieRadius / 1.35) * Math.cos(lastend + slice_angle/2); 
			var labelY = posy + (pieRadius / 1.35) * Math.sin(lastend + slice_angle/2);
			
			var labelText = round(100 * Inventory[idx].data[i].value / myTotal, 1);
			 
			context.fillStyle = "#000";		 
			context.font = "bold 12px Calibri";		 
			context.fillText(labelText+"%", labelX, labelY);

			context.fillStyle = Inventory[idx].data[i].colour;
			context.fillRect(Inventory[idx].data[i].x1, Inventory[idx].data[i].y1, 
				Inventory[idx].data[i].x2, Inventory[idx].data[i].y2);
			
			context.font = 'bold 12pt Calibri';
			context.fillStyle = '#000';
			context.textAlign="start"; 
			context.fillText(Inventory[idx].data[i].name + " = " + labelText+"%", Inventory[idx].data[i].x1 + 15, Inventory[idx].data[i].y1 + 10);		 	
			
			lastend += slice_angle;
						
			break;
		}
		pos += (anchor + sep);
	}

}

function drawNew(idx,idxc,data,ctype) {
	var items = data.length;
	var divrel = document.getElementById(idx),
		elem = document.getElementById(idxc),
		context = elem.getContext("2d"),
		elemLeft = elem.clientLeft + divrel.clientLeft,
		elemTop =  elem.clientTop + divrel.clientTop,
		elements = [];
	var coorX = 90, wBorder = true;    
	
	elem.width = document.getElementById(idx).offsetWidth - 5;
	elem.height = document.getElementById(idx).offsetHeight - 5;
		
	var space = 0, valor = 0, anchor = 0, pos = coorX, sep = 8, hue, longo, myMax =0,
		myTotal = 0, longitud = 0;
	var posx = 0, posy = 0, lastend = 0;		

	switch(ctype) {
	case 1:
		space = elem.width - 4 - (coorX + 35);
		longitud = elem.height - 40;
		break;
	case 4:
		wBorder = false;
		coorX += 5;
		longitud =  elem.width - 4 - (coorX + 35);
		space = elem.height - 40;	
		break;		
	case 3:
	case 2:
		coorX += 5;
		longitud =  elem.width - 4 - (coorX + 35);
		space = elem.height - 50;	
		break;
	}
		
	// Limpiar canvas
	context.fillStyle = '#fff';
	context.fillRect(0, 0, elem.width, elem.height);
	
	// Agregar evento de clic
	elem.addEventListener('click', function(event) {
		
		var x = parseInt(event.clientX-$(this).offset().left);
		var y = parseInt(event.clientY-$(this).offset().top);
	  		
		for (i = 0; i < items; i++) {
			console.log('x='+x+ '; x1='+data[i].x1+'; x2='+(data[i].x1+data[i].x2));
			if ((data[i].x1 <= x) && 
				((data[i].x1 +data[i].x2) >= x) &&
				(data[i].y1 <= y) &&
				((data[i].y1 +data[i].y2) >= y)) {
				alert('Click on: ' + data[i].code);
				break;
			}
		}
	}, false);	

	// Tamaño de columnas
	anchor = (longitud - (items*sep)) / items; 

	// Dibujar el eje X y Y
	if (wBorder == true) {
		context.beginPath();
		context.lineWidth = 1;
		context.strokeStyle = "#bbbbbb";
		context.lineCap="round";
		context.moveTo(pos - 1, 20);
		context.lineTo(pos - 1, elem.height - 30);
		context.lineTo(pos - 1 + elem.width - 4 - (pos + 35), elem.height - 30);
		context.stroke();	
	}

	// Calcula el valor mas alto entre los valores dados
	for (i =0; i < items; i++) {
		if (data[i].value > myMax) {
			myMax = data[i].value;			
		}
		myTotal += data[i].value;
	}
	
	switch(ctype) {
	case 1:
		pos = 20;		
		break;
	case 4:
		posx = coorX + (longitud * 0.25);
		posy = 20 + (space/2);	
		lastend = 0;
		anchor = (space - (items*sep)) / items; 		
		pos  = 20;		
		break;
	case 3:
	case 2:
		pos  = coorX;		
		break;
	}
	
	// Recorre los objetos 
	for (i =0; i < items; i++) {
		valor = (data[i].value*100)/myMax;
		//hue = Math.floor(Math.random() * 360);
		longo = (space*(valor/110));		
		data[i].colour = '#539fd8'; 

		switch (ctype) {
		case 1:
			// Barras verticales
			data[i].x1 = coorX;
			data[i].y1 = pos;
			data[i].x2 = longo;
			data[i].y2 = anchor;
		
			context.fillStyle = data[i].colour;
			context.fillRect(data[i].x1, 
				data[i].y1, 
				data[i].x2, 
				data[i].y2);
			
			context.font = 'bold 12pt Calibri';
			context.fillStyle = '#000';
			context.textAlign="start"; 
			context.fillText(data[i].value, longo + coorX + 2, pos + ((anchor+sep)/2));
			context.textAlign="end"; 
			context.fillStyle = '#000';
			context.fillText(data[i].name, coorX-3, pos + ((anchor+sep)/2));
			
			break;
		case 2:
			// Lineas
			data[i].x1 = pos + ((anchor+sep)/2); // coorX;
			data[i].y1 = space - 	longo;
			data[i].x2 = pos + ((anchor+sep)/2); //coorX + longo;
			data[i].y2 = space + 4; //pos + anchor;
		
			context.beginPath();
			context.arc(data[i].x1, data[i].y1, 3, 0*Math.PI, 2*Math.PI);
			context.fillStyle = "#539fd8";
			context.fill();
		
			if (i > 0) {
				context.beginPath();
				context.strokeStyle = "#539fd8";
				context.moveTo(data[i-1].x1,data[i-1].y1);
				context.lineTo(data[i].x1,data[i].y1);
				context.stroke();				
			}
			
			context.font = 'bold 12pt Calibri';
			context.fillStyle = '#000';
			context.textAlign="start"; 
			context.fillText(data[i].value, pos + ((anchor+sep)/2), space - longo - 10);
			context.textAlign="center"; 
			context.fillStyle = '#000';
			context.fillText(data[i].name, pos + ((anchor+sep)/2), space + 40);
			
			break;
		case 3:
			// Barras 2d
			data[i].x1 = pos;
			data[i].y1 = 20 + space - longo;
			data[i].x2 = anchor; 
			data[i].y2 = longo; 		
		
			context.fillStyle = data[i].colour;
			context.fillRect(data[i].x1, data[i].y1, 
				data[i].x2, data[i].y2);
			
			context.font = 'bold 12pt Calibri';
			context.fillStyle = '#000';
			context.textAlign="start"; 
			context.fillText(data[i].value, pos + ((anchor+sep)/2), 20 + space - longo - 10);
			context.textAlign="center"; 
			context.fillStyle = '#000';
			context.fillText(data[i].name, pos + ((anchor+sep)/2), space + 40);
			
			break;	
		case 4:
			// Pie
			
			if (data[i].colour != '') 
				data[i].colour = pastelColors();
			
			data[i].x1 = coorX + (longitud/2);
			data[i].y1 = pos;
			data[i].x2 = 10; 
			data[i].y2 = 10; 		
			
			var slice_angle = round((Math.PI * 2 * (data[i].value / myTotal)),2);
			
			context.fillStyle = data[i].colour;
			context.beginPath();
			context.moveTo(posx, posy);
			// Arc Parameters: x, y, radius, startingAngle (radians), endingAngle (radians), antiClockwise (boolean)
			context.arc(posx, posy, (posy*0.66), lastend, lastend + slice_angle, false);
			context.lineTo(posx, posy);
			context.fill();	
			
			var pieRadius = Math.min(posx,posy); 
			var labelX = posx + (pieRadius / 1.35) * Math.cos(lastend + slice_angle/2); 
			var labelY = posy + (pieRadius / 1.35) * Math.sin(lastend + slice_angle/2);
			
			var labelText = round(100 * data[i].value / myTotal, 1);
			 
			context.fillStyle = "#000";		 
			context.font = "bold 12px Calibri";		 
			context.fillText(labelText+"%", labelX, labelY);

			context.fillStyle = data[i].colour;
			context.fillRect(data[i].x1, data[i].y1, 
				data[i].x2, data[i].y2);
			
			context.font = 'bold 12pt Calibri';
			context.fillStyle = '#000';
			context.textAlign="start"; 
			context.fillText(data[i].name + " = " + labelText+"%", data[i].x1 + 15, data[i].y1 + 10);		 	
			
			lastend += slice_angle;
						
			break;
		}
		pos += (anchor + sep);
	}

}

function evalJSFromHtml(html) {
  var newElement = document.createElement('div');
  newElement.innerHTML = html;

  var scripts = newElement.getElementsByTagName("script");
  for (var i = 0; i < scripts.length; ++i) {
    var script = scripts[i];
    eval(script.innerHTML);
  }
}


global=this,function(t){function e(t,e,n,r){this.name=t,this.id=e,this.map=n,this.factory=r}for(var n={},r=0;r<t.length;r++){var o=t[r];t[r]=new e(o[0],o[1],o[2],o[3]),n[o[0]]=n[o[1]]||{},n[o[0]][o[1]]=o}return e.prototype.getExports=function(){var e=this;if(void 0===e.exports){e.exports={};var n=function(n){var r=e.map[n],o=t[r];if(!o)throw new Error("Bundle is missing a dependency: "+n);return o.getExports()};e.exports=e.factory(n,e.exports,e)||e.exports}return e.exports},e.prototype.bundle=n,t[0].getExports()}(function(t){return[["collections-website","lib/collections",{"./track-errors":35,"collections/shim-object":26,"collections/shim-array":24,"collections/list":13,"collections/map":20,"collections/fast-map":3,"collections/lru-map":18,"collections/lfu-map":11,"collections/sorted-map":31,"collections/sorted-array-map":29,"collections/dict":2,"collections/multi-map":21,"collections/weak-map":36,"collections/deque":1,"collections/set":22,"collections/fast-set":4,"collections/lru-set":19,"collections/lfu-set":12,"collections/sorted-set":32,"collections/sorted-array-set":30,"collections/sorted-array":28,"collections/heap":9,"collections/iterator":10,"./repl":34},function(t){t("./track-errors"),t("collections/shim-object"),t("collections/shim-array"),window.List=t("collections/list"),window.Map=t("collections/map"),window.FastMap=t("collections/fast-map"),window.LruMap=t("collections/lru-map"),window.LfuMap=t("collections/lfu-map"),window.SortedMap=t("collections/sorted-map"),window.SortedArrayMap=t("collections/sorted-array-map"),window.Dict=t("collections/dict"),window.MultiMap=t("collections/multi-map"),window.WeakMap=t("collections/weak-map"),window.Deque=t("collections/deque"),window.Set=t("collections/set"),window.FastSet=t("collections/fast-set"),window.LruSet=t("collections/lru-set"),window.LfuSet=t("collections/lfu-set"),window.SortedSet=t("collections/sorted-set"),window.SortedArraySet=t("collections/sorted-array-set"),window.SortedArray=t("collections/sorted-array"),window.Heap=t("collections/heap"),window.Iterator=t("collections/iterator");for(var e=t("./repl"),n=document.querySelectorAll(".repl"),r=0;r<n.length;r++)e(n[r])}],["collections","deque",{"./shim-object":26,"./generic-collection":5,"./generic-order":7,"./listen/range-changes":17},function(t,e,n){"use strict";function r(t,e){return this instanceof r?(this.capacity=this.snap(e),this.init(),this.length=0,this.front=0,void this.addEach(t)):new r(t,e)}function o(t,e,n,r,o){for(var i=0;o>i;++i)n[i+r]=t[i+e]}function i(t){return t>>>=0,t-=1,t|=t>>1,t|=t>>2,t|=t>>4,t|=t>>8,t|=t>>16,t+1}t("./shim-object");var s=t("./generic-collection"),a=t("./generic-order"),h=t("./listen/range-changes");n.exports=r,Object.addEach(r.prototype,s.prototype),Object.addEach(r.prototype,a.prototype),Object.addEach(r.prototype,h.prototype),r.prototype.maxCapacity=1<<30|0,r.prototype.minCapacity=16,r.prototype.constructClone=function(t){return new this.constructor(t,this.capacity)},r.prototype.add=function(t){this.push(t)},r.prototype.push=function(t){var e=arguments.length,n=this.length;if(this.dispatchesRangeChanges){for(var r=new Array(e),o=0;e>o;++o)r[o]=arguments[o];var i=[];this.dispatchBeforeRangeChange(r,i,n)}if(e>1){var s=this.capacity;if(n+e>s)for(var o=0;e>o;++o){this.ensureCapacity(n+1);var a=this.front+n&this.capacity-1;this[a]=arguments[o],n++,this.length=n}else{for(var a=this.front,o=0;e>o;++o)this[a+n&s-1]=arguments[o],a++;this.length=n+e}}else if(1===e){this.ensureCapacity(n+1);var h=this.front+n&this.capacity-1;this[h]=t,this.length=n+1}return this.dispatchesRangeChanges&&this.dispatchRangeChange(r,i,n),this.length},r.prototype.pop=function(){var t=this.length;if(0!==t){var e=this.front+t-1&this.capacity-1,n=this[e];return this.dispatchesRangeChanges&&this.dispatchBeforeRangeChange([],[n],t-1),this[e]=void 0,this.length=t-1,this.dispatchesRangeChanges&&this.dispatchRangeChange([],[n],t-1),n}},r.prototype.shift=function(){if(0!==this.length){var t=this.front,e=this[t];return this.dispatchesRangeChanges&&this.dispatchBeforeRangeChange([],[e],0),this[t]=void 0,this.front=t+1&this.capacity-1,this.length--,this.dispatchesRangeChanges&&this.dispatchRangeChange([],[e],0),e}},r.prototype.unshift=function(t){var e=this.length,n=arguments.length;if(this.dispatchesRangeChanges){for(var r=new Array(n),o=0;n>o;++o)r[o]=arguments[o];var i=[];this.dispatchBeforeRangeChange(r,i,0)}if(n>1){var s=this.capacity;if(e+n>s)for(var o=n-1;o>=0;o--){this.ensureCapacity(e+1);var s=this.capacity,a=(this.front-1&s-1^s)-s;this[a]=arguments[o],e++,this.front=a,this.length=e}else{for(var h=this.front,o=n-1;o>=0;o--){var a=(h-1&s-1^s)-s;this[a]=arguments[o],h=a}this.front=h,this.length=e+n}}else if(1===n){this.ensureCapacity(e+1);var s=this.capacity,a=(this.front-1&s-1^s)-s;this[a]=t,this.length=e+1,this.front=a}return this.dispatchesRangeChanges&&this.dispatchRangeChange(r,i,0),this.length},r.prototype.clear=function(){this.length=0,this.front=0,this.init()},r.prototype.ensureCapacity=function(t){this.capacity<t&&this.grow(this.snap(1.5*this.capacity+16))},r.prototype.grow=function(t){var e=this.front,n=this.capacity,r=new Array(n),i=this.length;if(o(this,0,r,0,n),this.capacity=t,this.init(),this.front=0,n>=e+i)o(r,e,this,0,i);else{var s=i-(e+i&n-1);o(r,e,this,0,s),o(r,0,this,s,i-s)}},r.prototype.init=function(){for(var t=0;t<this.capacity;++t)this[t]="nil"},r.prototype.snap=function(t){return"number"!=typeof t?this.minCapacity:i(Math.min(this.maxCapacity,Math.max(this.minCapacity,t)))},r.prototype.one=function(){return this.length>0?this[this.front]:void 0},r.prototype.peek=function(){return 0!==this.length?this[this.front]:void 0},r.prototype.poke=function(t){0!==this.length&&(this[this.front]=t)},r.prototype.peekBack=function(){var t=this.length;if(0!==t){var e=this.front+t-1&this.capacity-1;return this[e]}},r.prototype.pokeBack=function(t){var e=this.length;if(0!==e){var n=this.front+e-1&this.capacity-1;this[n]=t}},r.prototype.get=function(t){return t!==(0|t)||(0>t&&(t+=this.length),0>t||t>=this.length)?void 0:this[this.front+t&this.capacity-1]},r.prototype.indexOf=function(t,e){null==e&&(e=0),0>e&&(e+=this.length);for(var n=this.capacity-1;e<this.length;e++){var r=this.front+e&n;if(this[r]===t)return e}return-1},r.prototype.lastIndexOf=function(t,e){null==e&&(e=this.length-1),0>e&&(e+=this.length);for(var n=this.capacity-1;e>=0;e--){var r=this.front+e&n;if(this[r]===t)return e}return-1},r.prototype.find=function(t,e,n){e=e||Object.equals,null==n&&(n=0),0>n&&(n+=this.length);for(var r=this.capacity-1;n<this.length;n++){var o=this.front+n&r;if(e(t,this[o]))return n}return-1},r.prototype.findLast=function(t,e,n){e=e||Object.equals,null==n&&(n=this.length-1),0>n&&(n+=this.length);for(var r=this.capacity-1;n>=0;n--){var o=this.front+n&r;if(e(t,this[o]))return n}return-1},r.prototype.has=function(t,e){e=e||Object.equals;for(var n=this.capacity-1,r=0;r<this.length;r++){var o=this.front+r&n;if(this[o]===t)return!0}return!1},r.prototype.reduce=function(t,e){for(var n=arguments[2],r=this.capacity-1,o=0;o<this.length;o++){var i=this.front+o&r;e=t.call(n,e,this[i],o,this)}return e},r.prototype.reduceRight=function(t,e){for(var n=arguments[2],r=this.capacity-1,o=this.length-1;o>=0;o--){var i=this.front+o&r;e=t.call(n,e,this[i],o,this)}return e}}],["collections","dict",{"./shim":23,"./generic-collection":5,"./generic-map":6,"./listen/property-changes":16,dict:2},function(t,e,n){"use strict";function r(t,e){return this instanceof r?(e=e||Function.noop,this.getDefault=e,this.store={},this.length=0,void this.addEach(t)):new r(t,e)}function o(t){return"$"+t}function i(t){return t.slice(1)}var s=(t("./shim"),t("./generic-collection")),a=t("./generic-map"),h=t("./listen/property-changes");n.exports=r,r.Dict=r,Object.addEach(r.prototype,s.prototype),Object.addEach(r.prototype,a.prototype),Object.addEach(r.prototype,h.prototype),r.prototype.constructClone=function(t){return new this.constructor(t,this.getDefault)},r.prototype.assertString=function(t){if("string"!=typeof t)throw new TypeError("key must be a string but Got "+t)},r.prototype.get=function(t,e){this.assertString(t);var n=o(t);return n in this.store?this.store[n]:arguments.length>1?e:this.getDefault(t)},r.prototype.set=function(t,e){this.assertString(t);var n=o(t);return n in this.store?(this.dispatchesBeforeMapChanges&&this.dispatchBeforeMapChange(t,this.store[n]),this.store[n]=e,this.dispatchesMapChanges&&this.dispatchMapChange(t,e),!1):(this.dispatchesMapChanges&&this.dispatchBeforeMapChange(t,void 0),this.length++,this.store[n]=e,this.dispatchesMapChanges&&this.dispatchMapChange(t,e),!0)},r.prototype.has=function(t){this.assertString(t);var e=o(t);return e in this.store},r.prototype["delete"]=function(t){this.assertString(t);var e=o(t);return e in this.store?(this.dispatchesMapChanges&&this.dispatchBeforeMapChange(t,this.store[e]),delete this.store[o(t)],this.length--,this.dispatchesMapChanges&&this.dispatchMapChange(t,void 0),!0):!1},r.prototype.clear=function(){var t,e;for(e in this.store)t=i(e),this.dispatchesMapChanges&&this.dispatchBeforeMapChange(t,this.store[e]),delete this.store[e],this.dispatchesMapChanges&&this.dispatchMapChange(t,void 0);this.length=0},r.prototype.reduce=function(t,e,n){for(var r in this.store)e=t.call(n,e,this.store[r],i(r),this);return e},r.prototype.reduceRight=function(t,e,n){var r=this,o=this.store;return Object.keys(this.store).reduceRight(function(e,s){return t.call(n,e,o[s],i(s),r)},e)},r.prototype.one=function(){var t;for(t in this.store)return this.store[t]},r.prototype.toJSON=function(){return this.toObject()}}],["collections","fast-map",{"./shim":23,"./fast-set":4,"./generic-collection":5,"./generic-map":6,"./listen/property-changes":16,"fast-map":3},function(t,e,n){"use strict";function r(t,e,n,i){return this instanceof r?(e=e||Object.equals,n=n||Object.hash,i=i||Function.noop,this.contentEquals=e,this.contentHash=n,this.getDefault=i,this.store=new o(void 0,function(t,n){return e(t.key,n.key)},function(t){return n(t.key)}),this.length=0,void this.addEach(t)):new r(t,e,n,i)}var o=(t("./shim"),t("./fast-set")),i=t("./generic-collection"),s=t("./generic-map"),a=t("./listen/property-changes");n.exports=r,r.FastMap=r,Object.addEach(r.prototype,i.prototype),Object.addEach(r.prototype,s.prototype),Object.addEach(r.prototype,a.prototype),r.prototype.constructClone=function(t){return new this.constructor(t,this.contentEquals,this.contentHash,this.getDefault)},r.prototype.log=function(t,e){e=e||this.stringify,this.store.log(t,e)},r.prototype.stringify=function(t,e){return e+JSON.stringify(t.key)+": "+JSON.stringify(t.value)}}],["collections","fast-set",{"./shim":23,"./dict":2,"./list":13,"./generic-collection":5,"./generic-set":8,"./tree-log":33,"./listen/property-changes":16,"fast-set":4},function(t,e,n){"use strict";function r(t,e,n,o){return this instanceof r?(e=e||Object.equals,n=n||Object.hash,o=o||Function.noop,this.contentEquals=e,this.contentHash=n,this.getDefault=o,this.buckets=new this.Buckets(null,this.Bucket),this.length=0,void this.addEach(t)):new r(t,e,n,o)}{var o=(t("./shim"),t("./dict")),i=t("./list"),s=t("./generic-collection"),a=t("./generic-set"),h=t("./tree-log"),c=t("./listen/property-changes");Object.prototype.hasOwnProperty}n.exports=r,r.FastSet=r,Object.addEach(r.prototype,s.prototype),Object.addEach(r.prototype,a.prototype),Object.addEach(r.prototype,c.prototype),r.prototype.Buckets=o,r.prototype.Bucket=i,r.prototype.constructClone=function(t){return new this.constructor(t,this.contentEquals,this.contentHash,this.getDefault)},r.prototype.has=function(t){var e=this.contentHash(t);return this.buckets.get(e).has(t)},r.prototype.get=function(t,e){if(e)throw new Error("FastSet#get does not support second argument: equals");var n=this.contentHash(t),r=this.buckets;return r.has(n)?r.get(n).get(t):this.getDefault(t)},r.prototype["delete"]=function(t,e){if(e)throw new Error("FastSet#delete does not support second argument: equals");var n=this.contentHash(t),r=this.buckets;if(r.has(n)){var o=r.get(n);if(o["delete"](t))return this.length--,0===o.length&&r["delete"](n),!0}return!1},r.prototype.clear=function(){this.buckets.clear(),this.length=0},r.prototype.add=function(t){var e=this.contentHash(t),n=this.buckets;return n.has(e)||n.set(e,new this.Bucket(null,this.contentEquals)),n.get(e).has(t)?!1:(n.get(e).add(t),this.length++,!0)},r.prototype.reduce=function(t,e){var n=arguments[2],r=this.buckets,o=0;return r.reduce(function(e,r){return r.reduce(function(e,r){return t.call(n,e,r,o++,this)},e,this)},e,this)},r.prototype.one=function(){return this.length>0?this.buckets.one().one():void 0},r.prototype.iterate=function(){return this.buckets.values().flatten().iterate()},r.prototype.log=function(t,e,n,r){t=t||h.unicodeSharp,e=e||this.logNode,n||(n=console.log,r=console),n=n.bind(r);var o=this.buckets,i=o.keys();i.forEach(function(s,a){var h,c;a===i.length-1?(h=t.fromAbove,c=" "):0===a?(h=t.branchDown,c=t.strafe):(h=t.fromBoth,c=t.strafe);var p=o.get(s);n.call(r,h+t.through+t.branchDown+" "+s),p.forEach(function(o,i){var s,a;i===p.head.prev?(s=t.fromAbove,a=" "):(s=t.fromBoth,a=t.strafe);var h;e(i,function(e){h?n.call(r,c+" "+a+"  "+e):(n.call(r,c+" "+s+t.through+t.through+e),h=!0)},function(e){n.call(r,c+" "+t.strafe+"  "+e)})})})},r.prototype.logNode=function(t,e){var n=t.value;Object(n)===n?JSON.stringify(n,null,4).split("\n").forEach(function(t){e(" "+t)}):e(" "+n)}}],["collections","generic-collection",{"./shim-array":24},function(t,e,n){"use strict";function r(){throw new Error("Can't construct. GenericCollection is a mixin.")}n.exports=r,r.prototype.addEach=function(t){if(t&&Object(t)===t)if("function"==typeof t.forEach)t.forEach(this.add,this);else if("number"==typeof t.length)for(var e=0;e<t.length;e++)this.add(t[e],e);else Object.keys(t).forEach(function(e){this.add(t[e],e)},this);else if(t&&"number"==typeof t.length)for(var e=0;e<t.length;e++)this.add(t[e],e);return this},r.prototype.deleteEach=function(t,e){return t.forEach(function(t){this["delete"](t,e)},this),this},r.prototype.forEach=function(t){var e=arguments[1];return this.reduce(function(n,r,o,i,s){t.call(e,r,o,i,s)},void 0)},r.prototype.map=function(t){var e=arguments[1],n=[];return this.reduce(function(r,o,i,s,a){n.push(t.call(e,o,i,s,a))},void 0),n},r.prototype.enumerate=function(t){null==t&&(t=0);var e=[];return this.reduce(function(n,r){e.push([t++,r])},void 0),e},r.prototype.group=function(t,e,n){n=n||Object.equals;var r=[],o=[];return this.forEach(function(i,s,a){var h,s=t.call(e,i,s,a),c=o.indexOf(s,n);-1===c?(h=[],r.push([s,h]),o.push(s)):h=r[c][1],h.push(i)}),r},r.prototype.toArray=function(){return this.map(Function.identity)},r.prototype.toObject=function(){var t={};return this.reduce(function(e,n,r){t[r]=n},void 0),t},r.prototype.filter=function(t){var e=arguments[1],n=this.constructClone();return this.reduce(function(r,o,i,s,a){t.call(e,o,i,s,a)&&n.add(o,i)},void 0),n},r.prototype.every=function(t){var e=arguments[1];return this.reduce(function(n,r,o,i,s){return n&&t.call(e,r,o,i,s)},!0)},r.prototype.some=function(t){var e=arguments[1];return this.reduce(function(n,r,o,i,s){return n||t.call(e,r,o,i,s)},!1)},r.prototype.all=function(){return this.every(Boolean)},r.prototype.any=function(){return this.some(Boolean)},r.prototype.min=function(t){t=t||this.contentCompare||Object.compare;var e=!0;return this.reduce(function(n,r){return e?(e=!1,r):t(r,n)<0?r:n},void 0)},r.prototype.max=function(t){t=t||this.contentCompare||Object.compare;var e=!0;return this.reduce(function(n,r){return e?(e=!1,r):t(r,n)>0?r:n},void 0)},r.prototype.sum=function(t){return t=void 0===t?0:t,this.reduce(function(t,e){return t+e},t)},r.prototype.average=function(t){var e=void 0===t?0:t,n=void 0===t?0:t;return this.reduce(function(t,r){e+=r,n+=1},void 0),e/n},r.prototype.concat=function(){for(var t=this.constructClone(this),e=0;e<arguments.length;e++)t.addEach(arguments[e]);return t},r.prototype.flatten=function(){var t=this;return this.reduce(function(e,n){return n.forEach(function(t){this.push(t)},e,t),e},[])},r.prototype.zip=function(){var t=Array.prototype.slice.call(arguments);return t.unshift(this),Array.unzip(t)},r.prototype.join=function(t){return this.reduce(function(e,n){return void 0===e?n:e+t+n},void 0)},r.prototype.sorted=function(t,e,n){return t=t||this.contentCompare||Object.compare,t.by?(e=t.by,t=t.compare||this.contentCompare||Object.compare):e=e||Function.identity,void 0===n&&(n=1),this.map(function(t){return{by:e(t),value:t}}).sort(function(e,r){return t(e.by,r.by)*n}).map(function(t){return t.value})},r.prototype.reversed=function(){return this.constructClone(this).reverse()},r.prototype.clone=function(t,e){if(void 0===t)t=1/0;else if(0===t)return this;var n=this.constructClone();return this.forEach(function(r,o){n.add(Object.clone(r,t-1,e),o)},this),n},r.prototype.only=function(){return 1===this.length?this.one():void 0},r.prototype.iterator=function(){return this.iterate.apply(this,arguments)},t("./shim-array")}],["collections","generic-map",{"./shim-object":26,"./listen/map-changes":15,"./listen/property-changes":16},function(t,e,n){"use strict";function r(){throw new Error("Can't construct. GenericMap is a mixin.")}function o(t,e){this.key=t,this.value=e}var i=t("./shim-object"),s=t("./listen/map-changes"),a=t("./listen/property-changes");n.exports=r,i.addEach(r.prototype,s.prototype),i.addEach(r.prototype,a.prototype),r.prototype.isMap=!0,r.prototype.addEach=function(t){if(t&&i(t)===t)if("function"==typeof t.forEach)t.isMap===!0?t.forEach(function(t,e){this.set(e,t)},this):t.forEach(function(t){this.set(t[0],t[1])},this);else if("number"==typeof t.length)for(var e=0;e<t.length;e++)this.add(t[e],e);else i.keys(t).forEach(function(e){this.set(e,t[e])},this);else if(t&&"number"==typeof t.length)for(var e=0;e<t.length;e++)this.add(t[e],e);return this},r.prototype.get=function(t,e){var n=this.store.get(new this.Item(t));return n?n.value:arguments.length>1?e:this.getDefault(t)},r.prototype.set=function(t,e){var n=new this.Item(t,e),r=this.store.get(n),o=!1;return r?(this.dispatchesMapChanges&&this.dispatchBeforeMapChange(t,r.value),r.value=e,this.dispatchesMapChanges&&this.dispatchMapChange(t,e)):(this.dispatchesMapChanges&&this.dispatchBeforeMapChange(t,void 0),this.store.add(n)&&(this.length++,o=!0),this.dispatchesMapChanges&&this.dispatchMapChange(t,e)),o},r.prototype.add=function(t,e){return this.set(e,t)},r.prototype.has=function(t){return this.store.has(new this.Item(t))},r.prototype["delete"]=function(t){var e=new this.Item(t);if(this.store.has(e)){var n=this.store.get(e).value;return this.dispatchesMapChanges&&this.dispatchBeforeMapChange(t,n),this.store["delete"](e),this.length--,this.dispatchesMapChanges&&this.dispatchMapChange(t,void 0),!0}return!1},r.prototype.clear=function(){var t;this.dispatchesMapChanges&&(this.forEach(function(t,e){this.dispatchBeforeMapChange(e,t)},this),t=this.keys()),this.store.clear(),this.length=0,this.dispatchesMapChanges&&t.forEach(function(t){this.dispatchMapChange(t)},this)},r.prototype.reduce=function(t,e,n){return this.store.reduce(function(e,r){return t.call(n,e,r.value,r.key,this)},e,this)},r.prototype.reduceRight=function(t,e,n){return this.store.reduceRight(function(e,r){return t.call(n,e,r.value,r.key,this)},e,this)},r.prototype.keys=function(){return this.map(function(t,e){return e})},r.prototype.values=function(){return this.map(Function.identity)},r.prototype.entries=function(){return this.map(function(t,e){return[e,t]})},r.prototype.items=function(){return this.entries()},r.prototype.equals=function(t,e){if(e=e||i.equals,this===t)return!0;if(t&&"function"==typeof t.every)return t.length===this.length&&t.every(function(t,n){return e(this.get(n),t)},this);var n=i.keys(t);return n.length===this.length&&i.keys(t).every(function(n){return e(this.get(n),t[n])},this)},r.prototype.toJSON=function(){return this.entries()},r.prototype.Item=o,o.prototype.equals=function(t){return i.equals(this.key,t.key)&&i.equals(this.value,t.value)},o.prototype.compare=function(t){return i.compare(this.key,t.key)}}],["collections","generic-order",{"./shim-object":26},function(t,e,n){function r(){throw new Error("Can't construct. GenericOrder is a mixin.")}var o=t("./shim-object");n.exports=r,r.prototype.equals=function(t,e){if(e=e||this.contentEquals||o.equals,this===t)return!0;if(!t)return!1;return this.length===t.length&&this.zip(t).every(function(t){return e(t[0],t[1])})},r.prototype.compare=function(t,e){if(e=e||this.contentCompare||o.compare,this===t)return 0;if(!t)return 1;var n=Math.min(this.length,t.length),r=this.zip(t).reduce(function(t,r,o){return 0===t?o>=n?t:e(r[0],r[1]):t},0);return 0===r?this.length-t.length:r},r.prototype.toJSON=function(){return this.toArray()}}],["collections","generic-set",{},function(t,e,n){function r(){throw new Error("Can't construct. GenericSet is a mixin.")}n.exports=r,r.prototype.isSet=!0,r.prototype.union=function(t){var e=this.constructClone(this);return e.addEach(t),e},r.prototype.intersection=function(t){return this.constructClone(this.filter(function(e){return t.has(e)}))},r.prototype.difference=function(t){var e=this.constructClone(this);return e.deleteEach(t),e},r.prototype.symmetricDifference=function(t){var e=this.union(t),n=this.intersection(t);return e.difference(n)},r.prototype.deleteAll=function(t){return+this["delete"](t)},r.prototype.equals=function(t,e){var n=this;return t&&"function"==typeof t.reduce&&this.length===t.length&&t.reduce(function(t,r){return t&&n.has(r,e)},!0)},r.prototype.toJSON=function(){return this.toArray()},r.prototype.contains=function(t){return this.has(t)},r.prototype.remove=function(t){return this["delete"](t)},r.prototype.toggle=function(t){this.has(t)?this["delete"](t):this.add(t)}}],["collections","heap",{"./listen/array-changes":14,"./shim":23,"./generic-collection":5,"./listen/map-changes":15,"./listen/range-changes":17,"./listen/property-changes":16,heap:9},function(t,e,n){function r(t,e,n){return this instanceof r?(this.contentEquals=e||Object.equals,this.contentCompare=n||Object.compare,this.content=[],this.length=0,void this.addEach(t)):new r(t,e,n)}var o=(t("./listen/array-changes"),t("./shim"),t("./generic-collection")),i=t("./listen/map-changes"),s=t("./listen/range-changes"),a=t("./listen/property-changes");n.exports=r,r.Heap=r,Object.addEach(r.prototype,o.prototype),Object.addEach(r.prototype,a.prototype),Object.addEach(r.prototype,s.prototype),Object.addEach(r.prototype,i.prototype),r.prototype.constructClone=function(t){return new this.constructor(t,this.contentEquals,this.contentCompare)},r.prototype.push=function(t){this.content.push(t),this.float(this.content.length-1),this.length++},r.prototype.pop=function(){var t=this.content[0],e=this.content.pop();return this.content.length>0&&(this.content.set(0,e),this.sink(0)),this.length--,t},r.prototype.add=function(t){this.push(t)},r.prototype.indexOf=function(t){for(var e=0;e<this.length;e++)if(this.contentEquals(this.content[e],t))return e;return-1},r.prototype["delete"]=function(t,e){if(e)throw new Error("Heap#delete does not support second argument: equals");var n=this.indexOf(t);if(-1===n)return!1;var r=this.content.pop();if(this.length=this.content.length,n===this.content.length)return!0;this.content.set(n,r);var o=this.contentCompare(r,t);return o>0?this.float(n):0>o&&this.sink(n),!0},r.prototype.peek=function(){return this.length?this.content[0]:void 0},r.prototype.max=function(){return this.peek()},r.prototype.one=function(){return this.peek()},r.prototype.float=function(t){for(var e=this.content[t];t>0;){var n=Math.floor((t+1)/2)-1,r=this.content[n];if(!(this.contentCompare(r,e)<0))break;this.content.set(n,e),this.content.set(t,r),t=n}},r.prototype.sink=function(t){for(var e,n,r,o,i,s,a=this.content.length,h=this.content[t];;){if(o=2*(t+1),r=o-1,s=!1,a>r){var e=this.content[r],c=this.contentCompare(e,h);c>0&&(i=r,s=!0)}if(a>o){var n=this.content[o],c=this.contentCompare(n,s?e:h);c>0&&(i=o,s=!0)}if(!s)break;this.content.set(t,this.content[i]),this.content.set(i,h),t=i}},r.prototype.clear=function(){this.content.clear(),this.length=0},r.prototype.reduce=function(t,e){var n=arguments[2];return this.content.reduce(function(e,r,o){return t.call(n,e,r,o,this)},e,this)},r.prototype.reduceRight=function(t,e){var n=arguments[2];return this.content.reduceRight(function(e,r,o){return t.call(n,e,r,o,this)},e,this)},r.prototype.toJSON=function(){return this.toArray()},r.prototype.makeObservable=function(){this.content.addRangeChangeListener(this,"content"),this.content.addBeforeRangeChangeListener(this,"content"),this.content.addMapChangeListener(this,"content"),this.content.addBeforeMapChangeListener(this,"content")},r.prototype.handleContentRangeChange=function(t,e,n){this.dispatchRangeChange(t,e,n)},r.prototype.handleContentRangeWillChange=function(t,e,n){this.dispatchBeforeRangeChange(t,e,n)},r.prototype.handleContentMapChange=function(t,e){this.dispatchMapChange(e,t)},r.prototype.handleContentMapWillChange=function(t,e){this.dispatchBeforeMapChange(e,t)}}],["collections","iterator",{"./shim-object":26,"./generic-collection":5},function(e,n,r){"use strict";function o(t){if(!(this instanceof o))return new o(t);if(Array.isArray(t)||"string"==typeof t)return o.iterate(t);if(t=i(t),t instanceof o)return t;if(t.next)this.next=function(){return t.next()};else if(t.iterate){var e=t.iterate();this.next=function(){return e.next()}}else{if("[object Function]"!==i.prototype.toString.call(t))throw new TypeError("Can't iterate "+t);this.next=t}}r.exports=o;var i=e("./shim-object"),s=e("./generic-collection");o.prototype.forEach=s.prototype.forEach,o.prototype.map=s.prototype.map,o.prototype.filter=s.prototype.filter,o.prototype.every=s.prototype.every,o.prototype.some=s.prototype.some,o.prototype.any=s.prototype.any,o.prototype.all=s.prototype.all,o.prototype.min=s.prototype.min,o.prototype.max=s.prototype.max,o.prototype.sum=s.prototype.sum,o.prototype.average=s.prototype.average,o.prototype.flatten=s.prototype.flatten,o.prototype.zip=s.prototype.zip,o.prototype.enumerate=s.prototype.enumerate,o.prototype.sorted=s.prototype.sorted,o.prototype.group=s.prototype.group,o.prototype.reversed=s.prototype.reversed,o.prototype.toArray=s.prototype.toArray,o.prototype.toObject=s.prototype.toObject,o.prototype.iterator=s.prototype.iterator,o.prototype.constructClone=function(t){var e=[];return e.addEach(t),e},o.prototype.mapIterator=function(t){var e=o(this),n=arguments[1],r=0;if("[object Function]"!=i.prototype.toString.call(t))throw new TypeError;return new e.constructor(function(){return t.call(n,e.next(),r++,e)})},o.prototype.filterIterator=function(t){var e=o(this),n=arguments[1],r=0;if("[object Function]"!=i.prototype.toString.call(t))throw new TypeError;return new e.constructor(function(){for(var o;;)if(o=e.next(),t.call(n,o,r++,e))return o})},o.prototype.reduce=function(t){var e,n=o(this),r=arguments[1],s=arguments[2],a=0;if("[object Function]"!=i.prototype.toString.call(t))throw new TypeError;try{e=n.next(),r=arguments.length>1?t.call(s,r,e,a,n):e,a++}catch(h){if(isStopIteration(h)){if(arguments.length>1)return arguments[1];throw TypeError("cannot reduce a value from an empty iterator with no initial value")}throw h}try{for(;;)e=n.next(),r=t.call(s,r,e,a,n),a++}catch(h){if(isStopIteration(h))return r;throw h}},o.prototype.concat=function(){return o.concat(Array.prototype.concat.apply(this,arguments))},o.prototype.dropWhile=function(t){var e,n=o(this),r=arguments[1],s=!1;if("[object Function]"!=i.prototype.toString.call(t))throw new TypeError;return n.forEach(function(o,i){if(!t.call(r,o,i,n))throw s=!0,e=o,StopIteration}),s?n.constructor([e]).concat(n):n.constructor([])},o.prototype.takeWhile=function(t){var e=o(this),n=arguments[1];if("[object Function]"!=i.prototype.toString.call(t))throw new TypeError;return e.mapIterator(function(r,o){if(!t.call(n,r,o,e))throw StopIteration;return r})},o.prototype.zipIterator=function(){return o.unzip(Array.prototype.concat.apply(this,arguments))},o.prototype.enumerateIterator=function(t){return o.count(t).zipIterator(this)},o.iterate=function(t){var e;return e=0,new o(function(){if("object"==typeof t)for(;!(e in t);){if(e>=t.length)throw StopIteration;e+=1}else if(e>=t.length)throw StopIteration;var n=t[e];return e+=1,n})},o.cycle=function(t,e){arguments.length<2&&(e=1/0);var n=function(){throw StopIteration};return new o(function(){var r;try{return n()}catch(i){if(isStopIteration(i)){if(0>=e)throw i;return e--,r=o.iterate(t),(n=r.next.bind(r))()}throw i}})},o.concat=function(t){t=o(t);var e=function(){throw StopIteration};return new o(function(){var n;try{return e()}catch(r){if(isStopIteration(r))return n=o(t.next()),(e=n.next.bind(n))();throw r}})},o.unzip=function(t){return t=o(t).map(o),new o(0===t.length?[]:function(){var e,n=t.map(function(t){try{return t.next()}catch(n){if(!isStopIteration(n))throw n;e=!0}});if(e)throw StopIteration;return n})},o.zip=function(){return o.unzip(Array.prototype.slice.call(arguments))},o.chain=function(){return o.concat(Array.prototype.slice.call(arguments))},o.range=function(t,e,n){return arguments.length<3&&(n=1),arguments.length<2&&(e=t,t=0),t=t||0,n=n||1,new o(function(){if(t>=e)throw StopIteration;var r=t;return t+=n,r})},o.count=function(t,e){return o.range(t,1/0,e)},o.repeat=function(t,e){return new o.range(e).mapIterator(function(){return t})},"undefined"==typeof isStopIteration&&(t.isStopIteration=function(t){return"[object StopIteration]"===i.prototype.toString.call(t)}),"undefined"==typeof StopIteration&&(t.StopIteration={},i.prototype.toString=function(e){return function(){return this===t.StopIteration||this instanceof t.ReturnValue?"[object StopIteration]":e.call(this,arguments)}}(i.prototype.toString)),"undefined"==typeof ReturnValue&&(t.ReturnValue=function a(e){return this.message="Iteration stopped with "+e,Error.captureStackTrace&&Error.captureStackTrace(this,a),this instanceof t.ReturnValue?void(this.value=e):new t.ReturnValue(e)},ReturnValue.prototype=Error.prototype)}],["collections","lfu-map",{"./shim":23,"./lfu-set":12,"./generic-collection":5,"./generic-map":6,"./listen/property-changes":16,"lfu-map":11},function(t,e,n){"use strict";function r(t,e,n,i,s){return this instanceof r?(n=n||Object.equals,i=i||Object.hash,s=s||Function.noop,this.contentEquals=n,this.contentHash=i,this.getDefault=s,this.store=new o(void 0,e,function(t,e){return n(t.key,e.key)},function(t){return i(t.key)}),this.length=0,void this.addEach(t)):new r(t,e,n,i,s)}var o=(t("./shim"),t("./lfu-set")),i=t("./generic-collection"),s=t("./generic-map"),a=t("./listen/property-changes");n.exports=r,r.LfuMap=r,Object.addEach(r.prototype,i.prototype),Object.addEach(r.prototype,s.prototype),Object.addEach(r.prototype,a.prototype),r.prototype.constructClone=function(t){return new this.constructor(t,this.maxLength,this.contentEquals,this.contentHash,this.getDefault)},r.prototype.log=function(t,e){e=e||this.stringify,this.store.log(t,e)},r.prototype.stringify=function(t,e){return e+JSON.stringify(t.key)+": "+JSON.stringify(t.value)},r.prototype.addMapChangeListener=function(){if(!this.dispatchesMapChanges){var t=this;this.store.addBeforeRangeChangeListener(function(e,n){e.length&&n.length&&t.dispatchBeforeMapChange(n[0].key,void 0)}),this.store.addRangeChangeListener(function(e,n){e.length&&n.length&&t.dispatchMapChange(n[0].key,void 0)})}s.prototype.addMapChangeListener.apply(this,arguments)}}],["collections","lfu-set",{"./shim":23,"./set":22,"./generic-collection":5,"./generic-set":8,"./listen/property-changes":16,"./listen/range-changes":17,"lfu-set":12},function(t,e,n){"use strict";function r(t,e,n,o,i){return this instanceof r?(e=e||1/0,n=n||Object.equals,o=o||Object.hash,i=i||Function.noop,this.store=new s(void 0,function(t,e){return n(t.value,e.value)},function(t){return o(t.value)}),this.frequencyHead=new this.FrequencyNode(0),this.contentEquals=n,this.contentHash=o,this.getDefault=i,this.capacity=e,this.length=0,void this.addEach(t)):new r(t,e,n,o,i)}function o(t,e){this.value=t,this.frequencyNode=e}function i(t,e,n){this.frequency=t,this.values=new s,this.prev=e||this,this.next=n||this,e&&(e.next=this),n&&(n.prev=this)}var s=(t("./shim"),t("./set")),a=t("./generic-collection"),h=t("./generic-set"),c=t("./listen/property-changes"),p=t("./listen/range-changes");n.exports=r,r.LfuSet=r,Object.addEach(r.prototype,a.prototype),Object.addEach(r.prototype,h.prototype),Object.addEach(r.prototype,c.prototype),Object.addEach(r.prototype,p.prototype),r.prototype.constructClone=function(t){return new this.constructor(t,this.capacity,this.contentEquals,this.contentHash,this.getDefault)},r.prototype.has=function(t){return this.store.has(new this.Node(t))},r.prototype.get=function(t,e){if(e)throw new Error("LfuSet#get does not support second argument: equals");var n=this.store.get(new this.Node(t));if(void 0!==n){var r=n.frequencyNode,o=r.next;return o.frequency!==r.frequency+1&&(o=new this.FrequencyNode(r.frequency+1,r,o)),o.values.add(n),n.frequencyNode=o,r.values["delete"](n),0===r.values.length&&(r.prev.next=r.next,r.next.prev=r.prev),n.value}return this.getDefault(t)},r.prototype.add=function(t){if(this.has(t))return this.get(t),!1;var e,n,r=[],o=[];if(this.capacity>0){r.push(t),this.length+1>this.capacity&&(e=this.frequencyHead.next,n=e.values.order.head.next.value,o.push(n.value)),this.dispatchesRangeChanges&&this.dispatchBeforeRangeChange(r,o,0),o.length>0&&(this.store["delete"](n),e.values["delete"](n),1!==e.value&&0===e.values.length&&(this.frequencyHead.next=e.next,e.next.prev=this.frequencyHead));var i=new this.Node(t),s=this.frequencyHead.next;1!==s.frequency&&(s=new this.FrequencyNode(1,this.frequencyHead,s)),this.store.add(i),s.values.add(i),i.frequencyNode=s,this.length=this.length+r.length-o.length,this.dispatchesRangeChanges&&this.dispatchRangeChange(r,o,0)}return r.length!==o.length},r.prototype["delete"]=function(t,e){if(e)throw new Error("LfuSet#delete does not support second argument: equals");var n=this.store.get(new this.Node(t)),r=!!n;if(r){this.dispatchesRangeChanges&&this.dispatchBeforeRangeChange([],[t],0);var o=n.frequencyNode;this.store["delete"](n),o.values["delete"](n),0===o.values.length&&(o.prev.next=o.next,o.next.prev=o.prev),this.length--,this.dispatchesRangeChanges&&this.dispatchRangeChange([],[t],0)}return r},r.prototype.one=function(){return this.length>0?this.frequencyHead.next.values.one().value:void 0},r.prototype.clear=function(){this.store.clear(),this.frequencyHead.next=this.frequencyHead,this.length=0},r.prototype.reduce=function(t,e){for(var n=arguments[2],r=0,o=this.frequencyHead.next;0!==o.frequency;){var i=o.values;e=i.reduce(function(e,o){return t.call(n,e,o.value,r++,this)},e,this),o=o.next}return e},r.prototype.reduceRight=function(t,e){for(var n=arguments[2],r=this.length-1,o=this.frequencyHead.prev;0!==o.frequency;){var i=o.values;e=i.reduceRight(function(e,o){return t.call(n,e,o.value,r--,this)},e,this),o=o.prev}return e},r.prototype.iterate=function(){return this.store.map(function(t){return t.value}).iterate()},r.prototype.Node=o,r.prototype.FrequencyNode=i}],["collections","list",{"./shim":23,"./generic-collection":5,"./generic-order":7,"./listen/property-changes":16,"./listen/range-changes":17,list:13},function(t,e,n){"use strict";function r(t,e,n){if(!(this instanceof r))return new r(t,e,n);var o=this.head=new this.Node;o.next=o,o.prev=o,this.contentEquals=e||Object.equals,this.getDefault=n||Function.noop,this.length=0,this.addEach(t)}function o(t){this.head=t,this.at=t.next}function i(t){this.value=t,this.prev=null,this.next=null}n.exports=r;var s=(t("./shim"),t("./generic-collection")),a=t("./generic-order"),h=t("./listen/property-changes"),c=t("./listen/range-changes");r.List=r,Object.addEach(r.prototype,s.prototype),Object.addEach(r.prototype,a.prototype),Object.addEach(r.prototype,h.prototype),Object.addEach(r.prototype,c.prototype),r.prototype.constructClone=function(t){return new this.constructor(t,this.contentEquals,this.getDefault)},r.prototype.find=function(t,e,n){e=e||this.contentEquals;for(var r=this.head,o=this.scan(n,r.next);o!==r;){if(e(o.value,t))return o;o=o.next}},r.prototype.findLast=function(t,e,n){e=e||this.contentEquals;for(var r=this.head,o=this.scan(n,r.prev);o!==r;){if(e(o.value,t))return o;o=o.prev}},r.prototype.has=function(t,e){return!!this.find(t,e)},r.prototype.get=function(t,e){var n=this.find(t,e);return n?n.value:this.getDefault(t)},r.prototype["delete"]=function(t,e){var n=this.findLast(t,e);if(n){if(this.dispatchesRangeChanges){var r=[],o=[t];this.dispatchBeforeRangeChange(r,o,n.index)}return n["delete"](),this.length--,this.dispatchesRangeChanges&&(this.updateIndexes(n.next,n.index),this.dispatchRangeChange(r,o,n.index)),!0}return!1},r.prototype.deleteAll=function(t,e){e=e||this.contentEquals;for(var n=this.head,r=n.next,o=0;r!==n;)e(t,r.value)&&(r["delete"](),o++),r=r.next;return this.length-=o,o},r.prototype.clear=function(){var t,e;this.dispatchesRangeChanges&&(e=this.toArray(),t=[],this.dispatchBeforeRangeChange(t,e,0)),this.head.next=this.head.prev=this.head,this.length=0,this.dispatchesRangeChanges&&this.dispatchRangeChange(t,e,0)},r.prototype.add=function(t){var e=new this.Node(t);return this.dispatchesRangeChanges&&(e.index=this.length,this.dispatchBeforeRangeChange([t],[],e.index)),this.head.addBefore(e),this.length++,this.dispatchesRangeChanges&&this.dispatchRangeChange([t],[],e.index),!0},r.prototype.push=function(){var t=this.head;if(this.dispatchesRangeChanges){var e=Array.prototype.slice.call(arguments),n=[],r=this.length;this.dispatchBeforeRangeChange(e,n,r);var o=this.head.prev}for(var i=0;i<arguments.length;i++){var s=arguments[i],a=new this.Node(s);t.addBefore(a)}this.length+=arguments.length,this.dispatchesRangeChanges&&(this.updateIndexes(o.next,void 0===o.index?0:o.index+1),this.dispatchRangeChange(e,n,r))},r.prototype.unshift=function(){if(this.dispatchesRangeChanges){var t=Array.prototype.slice.call(arguments),e=[];this.dispatchBeforeRangeChange(t,e,0)}for(var n=this.head,r=0;r<arguments.length;r++){var o=arguments[r],i=new this.Node(o);n.addAfter(i),n=i}this.length+=arguments.length,this.dispatchesRangeChanges&&(this.updateIndexes(this.head.next,0),this.dispatchRangeChange(t,e,0))},r.prototype.pop=function(){var t,e=this.head;if(e.prev!==e){if(t=e.prev.value,this.dispatchesRangeChanges){var n=[],r=[t],o=this.length-1;this.dispatchBeforeRangeChange(n,r,o)}e.prev["delete"](),this.length--,this.dispatchesRangeChanges&&this.dispatchRangeChange(n,r,o)}return t},r.prototype.shift=function(){var t,e=this.head;if(e.prev!==e){if(t=e.next.value,this.dispatchesRangeChanges){var n=[],r=[t];this.dispatchBeforeRangeChange(n,r,0)}e.next["delete"](),this.length--,this.dispatchesRangeChanges&&(this.updateIndexes(this.head.next,0),this.dispatchRangeChange(n,r,0))}return t},r.prototype.peek=function(){return this.head!==this.head.next?this.head.next.value:void 0},r.prototype.poke=function(t){this.head!==this.head.next?this.head.next.value=t:this.push(t)},r.prototype.one=function(){return this.peek()},r.prototype.scan=function(t,e){var n=this.head;if("number"==typeof t){var r=t;if(r>=0)for(t=n.next;r&&(r--,t=t.next,t!=n););else for(t=n;0>r&&(r++,t=t.prev,t!=n););return t}return t||e},r.prototype.slice=function(t,e){var n=[],r=this.head;for(t=this.scan(t,r.next),e=this.scan(e,r);t!==e&&t!==r;)n.push(t.value),t=t.next;return n},r.prototype.splice=function(t,e){return this.swap(t,e,Array.prototype.slice.call(arguments,2))},r.prototype.swap=function(t,e,n){var r=t;t=this.scan(t,this.head),null==e&&(e=1/0),n=Array.from(n);for(var o=[],i=t;e--&&e>=0&&i!==this.head;)o.push(i.value),i=i.next;var s,a;this.dispatchesRangeChanges&&(s=t===this.head?this.length:t.prev===this.head?0:t.index,a=t.prev,this.dispatchBeforeRangeChange(n,o,s));for(var i=t,h=0,i=t;h<o.length;h++,i=i.next)i["delete"]();null==r&&i===this.head&&(i=this.head.next);for(var h=0;h<n.length;h++){var c=new this.Node(n[h]);i.addBefore(c)}return this.length+=n.length-o.length,this.dispatchesRangeChanges&&(t===this.head?this.updateIndexes(this.head.next,0):this.updateIndexes(a.next,a.index+1),this.dispatchRangeChange(n,o,s)),o},r.prototype.reverse=function(){if(this.dispatchesRangeChanges){var t=this.toArray(),e=t.reversed();this.dispatchBeforeRangeChange(e,t,0)}var n=this.head;do{var r=n.next;n.next=n.prev,n.prev=r,n=n.next}while(n!==this.head);return this.dispatchesRangeChanges&&this.dispatchRangeChange(e,t,0),this},r.prototype.sort=function(){this.swap(0,this.length,this.sorted())},r.prototype.reduce=function(t,e){for(var n=arguments[2],r=this.head,o=r.next;o!==r;)e=t.call(n,e,o.value,o,this),o=o.next;return e},r.prototype.reduceRight=function(t,e){for(var n=arguments[2],r=this.head,o=r.prev;o!==r;)e=t.call(n,e,o.value,o,this),o=o.prev;return e},r.prototype.updateIndexes=function(t,e){for(;t!==this.head;)t.index=e++,t=t.next},r.prototype.makeObservable=function(){this.head.index=-1,this.updateIndexes(this.head.next,0),this.dispatchesRangeChanges=!0},r.prototype.iterate=function(){return new o(this.head)},o.prototype.next=function(){if(this.at===this.head)throw StopIteration;var t=this.at.value;return this.at=this.at.next,t},r.prototype.Node=i,i.prototype["delete"]=function(){this.prev.next=this.next,this.next.prev=this.prev},i.prototype.addBefore=function(t){var e=this.prev;this.prev=t,t.prev=e,e.next=t,t.next=this},i.prototype.addAfter=function(t){var e=this.next;this.next=t,t.next=e,e.prev=t,t.prev=this}}],["collections","listen/array-changes",{"../shim":23,"../list":13,"weak-map":36,"./property-changes":16,"./range-changes":17,"./map-changes":15},function(t){function e(t){for(var e in t)Object.defineProperty(Array.prototype,e,{value:t[e],writable:!0,configurable:!0,enumerable:!1})}t("../shim");var n,r=(t("../list"),t("weak-map"),t("./property-changes")),o=t("./range-changes"),i=t("./map-changes"),s=(Array.prototype.splice,Array.prototype.slice),a=(Array.prototype.reverse,Array.prototype.sort),h=Array.prototype.swap,c=[],p={}.__proto__===Object.prototype;n=p?function(){this.__proto__=l}:function(){Object.defineProperties(this,u)},Object.defineProperty(Array.prototype,"makeObservable",{value:n,writable:!0,configurable:!0,enumerable:!1}),e(r.prototype),e(o.prototype),e(i.prototype);var u={isObservable:{value:!0,writable:!0,configurable:!0},makeObservable:{value:Function.noop,writable:!0,configurable:!0},reverse:{value:function(){var t=this.constructClone(this);return t.reverse(),this.swap(0,this.length,t),this},writable:!0,configurable:!0},sort:{value:function(){this.dispatchBeforeRangeChange(this,this,0);for(var t=0;t<this.length;t++)r.dispatchBeforeOwnPropertyChange(this,t,this[t]),this.dispatchBeforeMapChange(t,this[t]);a.apply(this,arguments);for(var t=0;t<this.length;t++)r.dispatchOwnPropertyChange(this,t,this[t]),this.dispatchMapChange(t,this[t]);return this.dispatchRangeChange(this,this,0),this},writable:!0,configurable:!0},swap:{value:function(t,e,n){if(n?Array.isArray(n)||(n=s.call(n)):n=c,0>t)t=this.length+t;else if(t>this.length){for(var o=t-this.length,i=Array(o+n.length),a=0,p=o;a<n.length;a++,p++)a in n&&(i[p]=n[a]);n=i,t=this.length}var u;if(0===e){if(0===n.length)return[];u=c}else u=s.call(this,t,t+e);var l=n.length-u.length,f=this.length,g=Math.max(this.length+l,t+n.length),d=Math.max(f,g);if(l&&r.dispatchBeforeOwnPropertyChange(this,"length",this.length),this.dispatchBeforeRangeChange(n,u,t),0===l)for(var a=t;a<t+n.length;a++)r.dispatchBeforeOwnPropertyChange(this,a,this[a]),this.dispatchBeforeMapChange(a,this[a]);else if(r.hasOwnPropertyChangeDescriptor(this))for(var a=t;d>a;a++)r.dispatchBeforeOwnPropertyChange(this,a,this[a]),this.dispatchBeforeMapChange(a,this[a]);t>f&&(this.length=t);var y=h.call(this,t,e,n);if(0===l)for(var a=t;a<t+n.length;a++)r.dispatchOwnPropertyChange(this,a,this[a]),this.dispatchMapChange(a,this[a]);else if(r.hasOwnPropertyChangeDescriptor(this))for(var a=t;d>a;a++)r.dispatchOwnPropertyChange(this,a,this[a]),this.dispatchMapChange(a,this[a]);return this.dispatchRangeChange(n,u,t),l&&r.dispatchOwnPropertyChange(this,"length",this.length),y},writable:!0,configurable:!0},splice:{value:function(t,e){return t>this.length&&(t=this.length),this.swap.call(this,t,e,s.call(arguments,2))},writable:!0,configurable:!0},set:{value:function(t,e){return this.swap(t,t>=this.length?0:1,[e]),!0},writable:!0,configurable:!0},shift:{value:function(){return this.splice(0,1)[0]},writable:!0,configurable:!0},pop:{value:function(){return this.length?this.splice(this.length-1,1)[0]:void 0},writable:!0,configurable:!0},push:{value:function(t){if(1===arguments.length)return this.splice(this.length,0,t);var e=s.call(arguments);return this.swap(this.length,0,e)},writable:!0,configurable:!0},unshift:{value:function(t){if(1===arguments.length)return this.splice(0,0,t);var e=s.call(arguments);return this.swap(0,0,e)},writable:!0,configurable:!0},clear:{value:function(){return this.splice(0,this.length)},writable:!0,configurable:!0}},l=Object.create(Array.prototype,u)}],["collections","listen/map-changes",{"weak-map":36,"../list":13,"../dict":2},function(t,e,n){"use strict";function r(){throw new Error("Can't construct. MapChanges is a mixin.")}var o=t("weak-map"),i=t("../list");n.exports=r;var s=(Object.prototype.hasOwnProperty,new o);r.prototype.getAllMapChangeDescriptors=function(){var e=t("../dict");return s.has(this)||s.set(this,e()),s.get(this)},r.prototype.getMapChangeDescriptor=function(t){var e=this.getAllMapChangeDescriptors();return t=t||"",e.has(t)||e.set(t,{willChangeListeners:new i,changeListeners:new i}),e.get(t)},r.prototype.addMapChangeListener=function(t,e,n){!this.isObservable&&this.makeObservable&&this.makeObservable();var r,o=this.getMapChangeDescriptor(e);r=n?o.willChangeListeners:o.changeListeners,r.push(t),Object.defineProperty(this,"dispatchesMapChanges",{value:!0,writable:!0,configurable:!0,enumerable:!1});var i=this;return function(){i&&(i.removeMapChangeListener(t,e,n),i=null)}},r.prototype.removeMapChangeListener=function(t,e,n){var r,o=this.getMapChangeDescriptor(e);r=n?o.willChangeListeners:o.changeListeners;var i=r.findLast(t);if(!i)throw new Error("Can't remove map change listener: does not exist: token "+JSON.stringify(e));i["delete"]()},r.prototype.dispatchMapChange=function(t,e,n){var r=this.getAllMapChangeDescriptors(),o="Map"+(n?"WillChange":"Change");r.forEach(function(r,i){if(!r.isActive){r.isActive=!0;var s;s=n?r.willChangeListeners:r.changeListeners;var a="handle"+(i.slice(0,1).toUpperCase()+i.slice(1))+o;try{s.forEach(function(n){if(n[a])n[a](e,t,this);else{if(!n.call)throw new Error("Handler "+n+" has no method "+a+" and is not callable");n.call(n,e,t,this)}},this)}finally{r.isActive=!1}}},this)},r.prototype.addBeforeMapChangeListener=function(t,e){return this.addMapChangeListener(t,e,!0)},r.prototype.removeBeforeMapChangeListener=function(t,e){return this.removeMapChangeListener(t,e,!0)},r.prototype.dispatchBeforeMapChange=function(t,e){return this.dispatchMapChange(t,e,!0)}}],["collections","listen/property-changes",{"../shim":23},function(t,e,n){function r(){throw new Error("This is an abstract interface. Mix it. Don't construct it")}function o(t,e,n){for(var r=t.active,o=t.current,i=r.length=o.length;i--;)r[i]=o[i];for(var i=0,s=r.length;s>i;i++){var a=r[i];if(o.indexOf(a)<0)return;var h=a;if(a=a[t.specificHandlerMethodName]||a[t.genericHandlerMethodName]||a,!a.call)throw new Error("No event listener for "+t.specificHandlerName+" or "+t.genericHandlerName+" or call on "+a);a.call(h,n,e,this)}}t("../shim");var i=Object.prototype.hasOwnProperty;n.exports=r,r.debug=!0,r.prototype.getOwnPropertyChangeDescriptor=function(t){this.__propertyChangeListeners__||Object.defineProperty(this,"__propertyChangeListeners__",{value:{},enumerable:!1,configurable:!0,writable:!0});var e=this.__propertyChangeListeners__;if(!i.call(e,t)){var n=String(t);n=n&&n[0].toUpperCase()+n.slice(1),e[t]={willChangeListeners:{current:[],active:[],specificHandlerMethodName:"handle"+n+"WillChange",genericHandlerMethodName:"handlePropertyWillChange"},changeListeners:{current:[],active:[],specificHandlerMethodName:"handle"+n+"Change",genericHandlerMethodName:"handlePropertyChange"}}}return e[t]},r.prototype.hasOwnPropertyChangeDescriptor=function(t){if(!this.__propertyChangeListeners__)return!1;if(!t)return!0;var e=this.__propertyChangeListeners__;return i.call(e,t)?!0:!1},r.prototype.addOwnPropertyChangeListener=function(t,e,n){this.makeObservable&&!this.isObservable&&this.makeObservable();var o,i=r.getOwnPropertyChangeDescriptor(this,t);o=n?i.willChangeListeners:i.changeListeners,r.makePropertyObservable(this,t),o.current.push(e);var s=this;return function(){r.removeOwnPropertyChangeListener(s,t,e,n),s=null}},r.prototype.addBeforeOwnPropertyChangeListener=function(t,e){return r.addOwnPropertyChangeListener(this,t,e,!0)},r.prototype.removeOwnPropertyChangeListener=function(t,e,n){var o,i=r.getOwnPropertyChangeDescriptor(this,t);o=n?i.willChangeListeners:i.changeListeners;var s=o.current.lastIndexOf(e);if(-1===s)throw new Error("Can't remove property change listener: does not exist: property name"+JSON.stringify(t));o.current.splice(s,1)},r.prototype.removeBeforeOwnPropertyChangeListener=function(t,e){return r.removeOwnPropertyChangeListener(this,t,e,!0)},r.prototype.dispatchOwnPropertyChange=function(t,e,n){var i=r.getOwnPropertyChangeDescriptor(this,t);if(!i.isActive){i.isActive=!0;var s;s=n?i.willChangeListeners:i.changeListeners;try{o.call(this,s,t,e)}finally{i.isActive=!1}}},r.prototype.dispatchBeforeOwnPropertyChange=function(t,e){return r.dispatchOwnPropertyChange(this,t,e,!0)},r.prototype.makePropertyObservable=function(t){if(!Array.isArray(this)){if(!Object.isExtensible(this,t))throw new Error("Can't make property "+JSON.stringify(t)+" observable on "+this+" because object is not extensible");var e;"object"==typeof this.__state__?e=this.__state__:(e={},Object.isExtensible(this,"__state__")&&Object.defineProperty(this,"__state__",{value:e,writable:!0,enumerable:!1})),e[t]=this[t],this.__overriddenPropertyDescriptors__||(n={},Object.defineProperty(this,"__overriddenPropertyDescriptors__",{value:{},enumerable:!1,writable:!0,configurable:!0}));var n=this.__overriddenPropertyDescriptors__;if(!i.call(n,t)){{var o,s=this;Object.getOwnPropertyDescriptor(s,t)}do{if(o=Object.getOwnPropertyDescriptor(s,t))break;s=Object.getPrototypeOf(s)}while(s);if(o=o||{value:void 0,enumerable:!0,writable:!0,configurable:!0},o.configurable&&(n[t]=o,o.writable||o.set)){var a;a="value"in o?{get:function(){return o.value},set:function(n){return n===o.value?n:(r.dispatchBeforeOwnPropertyChange(this,t,o.value),o.value=n,e[t]=n,r.dispatchOwnPropertyChange(this,t,n),n)},enumerable:o.enumerable,configurable:!0}:{get:function(){return o.get?o.get.apply(this,arguments):void 0},set:function(n){var i;return o.get&&(i=o.get.apply(this,arguments)),o.set&&o.set.apply(this,arguments),o.get&&(n=o.get.apply(this,arguments),e[t]=n),n===i?n:(r.dispatchBeforeOwnPropertyChange(this,t,i),r.dispatchOwnPropertyChange(this,t,n),n)},enumerable:o.enumerable,configurable:!0},Object.defineProperty(this,t,a)}}}},r.getOwnPropertyChangeDescriptor=function(t,e){return t.getOwnPropertyChangeDescriptor?t.getOwnPropertyChangeDescriptor(e):r.prototype.getOwnPropertyChangeDescriptor.call(t,e)},r.hasOwnPropertyChangeDescriptor=function(t,e){return t.hasOwnPropertyChangeDescriptor?t.hasOwnPropertyChangeDescriptor(e):r.prototype.hasOwnPropertyChangeDescriptor.call(t,e)},r.addOwnPropertyChangeListener=function(t,e,n,o){return Object.isObject(t)?t.addOwnPropertyChangeListener?t.addOwnPropertyChangeListener(e,n,o):r.prototype.addOwnPropertyChangeListener.call(t,e,n,o):void 0},r.removeOwnPropertyChangeListener=function(t,e,n,o){return Object.isObject(t)?t.removeOwnPropertyChangeListener?t.removeOwnPropertyChangeListener(e,n,o):r.prototype.removeOwnPropertyChangeListener.call(t,e,n,o):void 0},r.dispatchOwnPropertyChange=function(t,e,n,o){return Object.isObject(t)?t.dispatchOwnPropertyChange?t.dispatchOwnPropertyChange(e,n,o):r.prototype.dispatchOwnPropertyChange.call(t,e,n,o):void 0},r.addBeforeOwnPropertyChangeListener=function(t,e,n){return r.addOwnPropertyChangeListener(t,e,n,!0)},r.removeBeforeOwnPropertyChangeListener=function(t,e,n){return r.removeOwnPropertyChangeListener(t,e,n,!0)},r.dispatchBeforeOwnPropertyChange=function(t,e,n){return r.dispatchOwnPropertyChange(t,e,n,!0)},r.makePropertyObservable=function(t,e){return t.makePropertyObservable?t.makePropertyObservable(e):r.prototype.makePropertyObservable.call(t,e)}}],["collections","listen/range-changes",{"weak-map":36,"../dict":2},function(t,e,n){"use strict";function r(){throw new Error("Can't construct. RangeChanges is a mixin.")}var o=t("weak-map"),i=t("../dict"),s=new o;n.exports=r,r.prototype.getAllRangeChangeDescriptors=function(){return s.has(this)||s.set(this,i()),s.get(this)},r.prototype.getRangeChangeDescriptor=function(t){var e=this.getAllRangeChangeDescriptors();return t=t||"",e.has(t)||e.set(t,{isActive:!1,changeListeners:[],willChangeListeners:[]}),e.get(t)},r.prototype.addRangeChangeListener=function(t,e,n){!this.isObservable&&this.makeObservable&&this.makeObservable();var r,o=this.getRangeChangeDescriptor(e);r=n?o.willChangeListeners:o.changeListeners,r.push(t),Object.defineProperty(this,"dispatchesRangeChanges",{value:!0,writable:!0,configurable:!0,enumerable:!1});var i=this;return function(){i&&(i.removeRangeChangeListener(t,e,n),i=null)}},r.prototype.removeRangeChangeListener=function(t,e,n){var r,o=this.getRangeChangeDescriptor(e);r=n?o.willChangeListeners:o.changeListeners;var i=r.lastIndexOf(t);if(-1===i)throw new Error("Can't remove range change listener: does not exist: token "+JSON.stringify(e));r.splice(i,1)},r.prototype.dispatchRangeChange=function(t,e,n,r){var o=this.getAllRangeChangeDescriptors(),i="Range"+(r?"WillChange":"Change");o.forEach(function(o,s){if(!o.isActive){o.isActive=!0;var a;a=r?o.willChangeListeners:o.changeListeners;var h="handle"+(s.slice(0,1).toUpperCase()+s.slice(1))+i;try{a.slice().forEach(function(o){if(!(a.indexOf(o)<0))if(o[h])o[h](t,e,n,this,r);else{if(!o.call)throw new Error("Handler "+o+" has no method "+h+" and is not callable");o.call(this,t,e,n,this,r)}},this)}finally{o.isActive=!1}}},this)},r.prototype.addBeforeRangeChangeListener=function(t,e){return this.addRangeChangeListener(t,e,!0)},r.prototype.removeBeforeRangeChangeListener=function(t,e){return this.removeRangeChangeListener(t,e,!0)},r.prototype.dispatchBeforeRangeChange=function(t,e,n){return this.dispatchRangeChange(t,e,n,!0)}}],["collections","lru-map",{"./shim":23,"./lru-set":19,"./generic-collection":5,"./generic-map":6,"./listen/property-changes":16,"lru-map":18},function(t,e,n){"use strict";function r(t,e,n,i,s){return this instanceof r?(n=n||Object.equals,i=i||Object.hash,s=s||Function.noop,this.contentEquals=n,this.contentHash=i,this.getDefault=s,this.store=new o(void 0,e,function(t,e){return n(t.key,e.key)},function(t){return i(t.key)}),this.length=0,void this.addEach(t)):new r(t,e,n,i,s)}var o=(t("./shim"),t("./lru-set")),i=t("./generic-collection"),s=t("./generic-map"),a=t("./listen/property-changes");n.exports=r,r.LruMap=r,Object.addEach(r.prototype,i.prototype),Object.addEach(r.prototype,s.prototype),Object.addEach(r.prototype,a.prototype),r.prototype.constructClone=function(t){return new this.constructor(t,this.maxLength,this.contentEquals,this.contentHash,this.getDefault)},r.prototype.log=function(t,e){e=e||this.stringify,this.store.log(t,e)},r.prototype.stringify=function(t,e){return e+JSON.stringify(t.key)+": "+JSON.stringify(t.value)},r.prototype.addMapChangeListener=function(){if(!this.dispatchesMapChanges){var t=this;this.store.addBeforeRangeChangeListener(function(e,n){e.length&&n.length&&t.dispatchBeforeMapChange(n[0].key,void 0)}),this.store.addRangeChangeListener(function(e,n){e.length&&n.length&&t.dispatchMapChange(n[0].key,void 0)})}s.prototype.addMapChangeListener.apply(this,arguments)}}],["collections","lru-set",{"./shim":23,"./set":22,"./generic-collection":5,"./generic-set":8,"./listen/property-changes":16,"./listen/range-changes":17,"lru-set":19},function(t,e,n){"use strict";function r(t,e,n,i,s){return this instanceof r?(e=e||1/0,n=n||Object.equals,i=i||Object.hash,s=s||Function.noop,this.store=new o(void 0,n,i),this.contentEquals=n,this.contentHash=i,this.getDefault=s,this.capacity=e,this.length=0,void this.addEach(t)):new r(t,e,n,i,s)}var o=(t("./shim"),t("./set")),i=t("./generic-collection"),s=t("./generic-set"),a=t("./listen/property-changes"),h=t("./listen/range-changes");n.exports=r,r.LruSet=r,Object.addEach(r.prototype,i.prototype),Object.addEach(r.prototype,s.prototype),Object.addEach(r.prototype,a.prototype),Object.addEach(r.prototype,h.prototype),r.prototype.constructClone=function(t){return new this.constructor(t,this.capacity,this.contentEquals,this.contentHash,this.getDefault)},r.prototype.has=function(t){return this.store.has(t)},r.prototype.get=function(t,e){if(e)throw new Error("LruSet#get does not support second argument: equals");return t=this.store.get(t),void 0!==t?(this.store["delete"](t),this.store.add(t)):t=this.getDefault(t),t},r.prototype.add=function(t){var e,n=this.store.has(t),r=[],o=[];return n?(this.store["delete"](t),this.store.add(t)):this.capacity>0&&(r.push(t),this.length>=this.capacity&&(e=this.store.order.head.next,o.push(e.value)),this.dispatchesRangeChanges&&this.dispatchBeforeRangeChange(r,o,0),this.store.add(t),o.length>0&&this.store["delete"](e.value),this.length=this.length+r.length-o.length,this.dispatchesRangeChanges&&this.dispatchRangeChange(r,o,0)),r.length!==o.length},r.prototype["delete"]=function(t,e){if(e)throw new Error("LruSet#delete does not support second argument: equals");var n=this.store.has(t);return n&&(this.dispatchesRangeChanges&&this.dispatchBeforeRangeChange([],[t],0),this.store["delete"](t),this.length--,this.dispatchesRangeChanges&&this.dispatchRangeChange([],[t],0)),n},r.prototype.one=function(){return this.length>0?this.store.one():void 0},r.prototype.clear=function(){this.store.clear(),this.length=0},r.prototype.reduce=function(t,e){var n=arguments[2],r=this.store,o=0;return r.reduce(function(e,r){return t.call(n,e,r,o++,this)},e,this)},r.prototype.reduceRight=function(t,e){var n=arguments[2],r=this.store,o=this.length-1;return r.reduceRight(function(e,r){return t.call(n,e,r,o--,this)},e,this)},r.prototype.iterate=function(){return this.store.iterate()}}],["collections","map",{"./shim":23,"./set":22,"./generic-collection":5,"./generic-map":6,"./listen/property-changes":16,map:20},function(t,e,n){"use strict";function r(t,e,n,i){return this instanceof r?(e=e||Object.equals,n=n||Object.hash,i=i||Function.noop,this.contentEquals=e,this.contentHash=n,this.getDefault=i,this.store=new o(void 0,function(t,n){return e(t.key,n.key)},function(t){return n(t.key)}),this.length=0,void this.addEach(t)):new r(t,e,n,i)}var o=(t("./shim"),t("./set")),i=t("./generic-collection"),s=t("./generic-map"),a=t("./listen/property-changes");n.exports=r,r.Map=r,Object.addEach(r.prototype,i.prototype),Object.addEach(r.prototype,s.prototype),Object.addEach(r.prototype,a.prototype),r.prototype.constructClone=function(t){return new this.constructor(t,this.contentEquals,this.contentHash,this.getDefault)},r.prototype.log=function(t,e,n,r){e=e||this.logNode,this.store.log(t,function(t,n,r){e(t.value.value,n,r)},n,r)},r.prototype.logNode=function(t,e){e(" key: "+t.key),e(" value: "+t.value)}}],["collections","multi-map",{"./map":20,"multi-map":21},function(t,e,n){"use strict";function r(t,e,n,i){return this instanceof r?(this.bucket=e||this.bucket,void o.call(this,t,n,i,function(t){var e=this.bucket(t);return o.prototype.set.call(this,t,e),e})):new r(t,e,n,i)}var o=t("./map");n.exports=r,r.MultiMap=r,r.prototype=Object.create(o.prototype),r.prototype.constructor=r,r.prototype.constructClone=function(t){return new this.constructor(t,this.bucket,this.contentEquals,this.contentHash)},r.prototype.set=function(t,e){var n=this.get(t);n.swap(0,n.length,e)},r.prototype.bucket=function(){return[]}}],["collections","set",{"./shim":23,"./list":13,"./fast-set":4,"./generic-collection":5,"./generic-set":8,"./listen/property-changes":16,"./listen/range-changes":17,set:22},function(t,e,n){"use strict";function r(t,e,n,o){return this instanceof r?(e=e||Object.equals,n=n||Object.hash,o=o||Function.noop,this.contentEquals=e,this.contentHash=n,this.getDefault=o,this.order=new this.Order(void 0,e),this.store=new this.Store(void 0,function(t,n){return e(t.value,n.value)},function(t){return n(t.value)}),this.length=0,void this.addEach(t)):new r(t,e,n,o)}var o=(t("./shim"),t("./list")),i=t("./fast-set"),s=t("./generic-collection"),a=t("./generic-set"),h=t("./listen/property-changes"),c=t("./listen/range-changes");n.exports=r,r.Set=r,Object.addEach(r.prototype,s.prototype),Object.addEach(r.prototype,a.prototype),Object.addEach(r.prototype,h.prototype),Object.addEach(r.prototype,c.prototype),r.prototype.Order=o,r.prototype.Store=i,r.prototype.constructClone=function(t){return new this.constructor(t,this.contentEquals,this.contentHash,this.getDefault)},r.prototype.has=function(t){var e=new this.order.Node(t);return this.store.has(e)},r.prototype.get=function(t,e){if(e)throw new Error("Set#get does not support second argument: equals");var n=new this.order.Node(t);return n=this.store.get(n),n?n.value:this.getDefault(t)},r.prototype.add=function(t){var e=new this.order.Node(t);if(!this.store.has(e)){var n=this.length;return this.dispatchesRangeChanges&&this.dispatchBeforeRangeChange([t],[],n),this.order.add(t),e=this.order.head.prev,this.store.add(e),this.length++,this.dispatchesRangeChanges&&this.dispatchRangeChange([t],[],n),!0}return!1},r.prototype["delete"]=function(t,e){if(e)throw new Error("Set#delete does not support second argument: equals");var n=new this.order.Node(t);return this.store.has(n)?(n=this.store.get(n),this.dispatchesRangeChanges&&this.dispatchBeforeRangeChange([],[t],n.index),this.store["delete"](n),this.order.splice(n,1),this.length--,this.dispatchesRangeChanges&&this.dispatchRangeChange([],[t],n.index),!0):!1},r.prototype.pop=function(){if(this.length){var t=this.order.head.prev.value;return this["delete"](t),t}},r.prototype.shift=function(){if(this.length){var t=this.order.head.next.value;return this["delete"](t),t}},r.prototype.one=function(){return this.length>0?this.store.one().value:void 0},r.prototype.clear=function(){var t;this.dispatchesRangeChanges&&(t=this.toArray(),this.dispatchBeforeRangeChange([],t,0)),this.store.clear(),this.order.clear(),this.length=0,this.dispatchesRangeChanges&&this.dispatchRangeChange([],t,0)},r.prototype.reduce=function(t,e){var n=arguments[2],r=this.order,o=0;return r.reduce(function(e,r){return t.call(n,e,r,o++,this)},e,this)},r.prototype.reduceRight=function(t,e){var n=arguments[2],r=this.order,o=this.length-1;return r.reduceRight(function(e,r){return t.call(n,e,r,o--,this)},e,this)},r.prototype.iterate=function(){return this.order.iterate()},r.prototype.log=function(){var t=this.store;return t.log.apply(t,arguments)},r.prototype.makeObservable=function(){this.order.makeObservable()}}],["collections","shim",{"./shim-array":24,"./shim-object":26,"./shim-function":25,"./shim-regexp":27},function(t){t("./shim-array"),t("./shim-object"),t("./shim-function"),t("./shim-regexp")}],["collections","shim-array",{"./shim-function":25,"./generic-collection":5,"./generic-order":7,"weak-map":36},function(t,e,n){"use strict";function r(t,e){Object.defineProperty(Array.prototype,t,{value:e,writable:!0,configurable:!0,enumerable:!1})}function o(t,e,n){this.array=t,this.start=null==e?0:e,this.end=n}var i=(t("./shim-function"),t("./generic-collection")),s=t("./generic-order"),a=t("weak-map");n.exports=Array;var h=Array.prototype.splice,c=Array.prototype.slice;Array.empty=[],Object.freeze&&Object.freeze(Array.empty),Array.from=function(t){var e=[];return e.addEach(t),e},Array.unzip=function(t){for(var e=[],n=1/0,r=0;r<t.length;r++){var o=t[r];t[r]=o.toArray(),o.length<n&&(n=o.length)}for(var r=0;r<t.length;r++)for(var o=t[r],i=0;i<o.length;i++)n>i&&i in o&&(e[i]=e[i]||[],e[i][r]=o[i]);return e},r("addEach",i.prototype.addEach),r("deleteEach",i.prototype.deleteEach),r("toArray",i.prototype.toArray),r("toObject",i.prototype.toObject),r("all",i.prototype.all),r("any",i.prototype.any),r("min",i.prototype.min),r("max",i.prototype.max),r("sum",i.prototype.sum),r("average",i.prototype.average),r("only",i.prototype.only),r("flatten",i.prototype.flatten),r("zip",i.prototype.zip),r("enumerate",i.prototype.enumerate),r("group",i.prototype.group),r("sorted",i.prototype.sorted),r("reversed",i.prototype.reversed),r("constructClone",function(t){var e=new this.constructor;return e.addEach(t),e}),r("has",function(t,e){return-1!==this.find(t,e)}),r("get",function(t,e){if(+t!==t)throw new Error("Indicies must be numbers");return!t in this?e:this[t]}),r("set",function(t,e){return this[t]=e,!0}),r("add",function(t){return this.push(t),!0}),r("delete",function(t,e){var n=this.find(t,e);return-1!==n?(this.splice(n,1),!0):!1}),r("deleteAll",function(t,e){e=e||this.contentEquals||Object.equals;for(var n=0,r=0;r<this.length;)e(t,this[r])?(this.swap(r,1),n++):r++;return n}),r("find",function(t,e){e=e||this.contentEquals||Object.equals;for(var n=0;n<this.length;n++)if(n in this&&e(t,this[n]))return n;return-1}),r("findLast",function(t,e){e=e||this.contentEquals||Object.equals;var n=this.length;do if(n--,n in this&&e(this[n],t))return n;while(n>0);return-1}),r("swap",function(t,e,n){var r,o,i,s,a;if(t>this.length&&(this.length=t),"undefined"!=typeof n){if(r=[t,e],Array.isArray(n)||(n=c.call(n)),i=0,o=n.length,1e3>o){for(i;o>i;i++)r[i+2]=n[i];return h.apply(this,r)}for(a=h.apply(this,r),i;o>i;){for(r=[t+i,0],s=2;1002>s&&o>i;s++,i++)r[s]=n[i];h.apply(this,r)}return a}return"undefined"!=typeof e?h.call(this,t,e):"undefined"!=typeof t?h.call(this,t):[]}),r("peek",function(){return this[0]}),r("poke",function(t){this.length>0&&(this[0]=t)}),r("peekBack",function(){return this.length>0?this[this.length-1]:void 0}),r("pokeBack",function(t){this.length>0&&(this[this.length-1]=t)}),r("one",function(){for(var t in this)if(Object.owns(this,t))return this[t]}),r("clear",function(){return this.length=0,this}),r("compare",function(t,e){e=e||Object.compare;var n,r,o,i,a;if(this===t)return 0;if(!t||!Array.isArray(t))return s.prototype.compare.call(this,t,e);for(r=Math.min(this.length,t.length),n=0;r>n;n++)if(n in this){if(!(n in t))return-1;if(o=this[n],i=t[n],a=e(o,i))return a}else if(n in t)return 1;return this.length-t.length}),r("equals",function(t,e){e=e||Object.equals;var n,r,o=0,i=this.length;if(this===t)return!0;if(!t||!Array.isArray(t))return s.prototype.equals.call(this,t);if(i!==t.length)return!1;for(;i>o;++o)if(o in this){if(!(o in t))return!1;if(n=this[o],r=t[o],!e(n,r))return!1}else if(o in t)return!1;return!0}),r("clone",function(t,e){if(null==t)t=1/0;else if(0===t)return this;if(e=e||new a,e.has(this))return e.get(this);var n=new Array(this.length);e.set(this,n);for(var r in this)n[r]=Object.clone(this[r],t-1,e);return n}),r("iterate",function(t,e){return new o(this,t,e)}),r("Iterator",o),o.prototype.next=function(){if(this.start===(null==this.end?this.array.length:this.end))throw StopIteration;return this.array[this.start++]}}],["collections","shim-function",{},function(t,e,n){n.exports=Function,Function.noop=function(){},Function.identity=function(t){return t},Function.by=function(t,e){e=e||Object.compare,t=t||Function.identity;var n=function(n,r){return e(t(n),t(r))};return n.compare=e,n.by=t,n},Function.get=function(t){return function(e){return Object.get(e,t)}}}],["collections","shim-object",{"weak-map":36},function(t,e,n){"use strict";var r=t("weak-map");n.exports=Object,Object.empty=Object.freeze(Object.create(null)),Object.isObject=function(t){return Object(t)===t},Object.getValueOf=function(t){return t&&"function"==typeof t.valueOf&&(t=t.valueOf()),t};var o=new r;Object.hash=function(t){return t&&"function"==typeof t.hash?""+t.hash():Object(t)===t?(o.has(t)||o.set(t,Math.random().toString(36).slice(2)),o.get(t)):""+t};var i=Object.prototype.hasOwnProperty;Object.owns=function(t,e){return i.call(t,e)},Object.has=function(t,e){if("object"!=typeof t)throw new Error("Object.has can't accept non-object: "+typeof t);if(t&&"function"==typeof t.has)return t.has(e);if("string"==typeof e)return e in t&&t[e]!==Object.prototype[e];throw new Error("Key must be a string for Object.has on plain objects")},Object.get=function(t,e,n){if("object"!=typeof t)throw new Error("Object.get can't accept non-object: "+typeof t);return t&&"function"==typeof t.get?t.get(e,n):Object.has(t,e)?t[e]:n},Object.set=function(t,e,n){t&&"function"==typeof t.set?t.set(e,n):t[e]=n},Object.addEach=function(t,e){if(e)if("function"!=typeof e.forEach||e.hasOwnProperty("forEach"))if("number"==typeof e.length)for(var n=0;n<e.length;n++)t[n]=e[n];else Object.keys(e).forEach(function(n){t[n]=e[n]});else e.forEach(e.isMap===!0?function(e,n){t[n]=e}:function(e){t[e[0]]=e[1]});else;return t},Object.forEach=function(t,e,n){Object.keys(t).forEach(function(r){e.call(n,t[r],r,t)})},Object.map=function(t,e,n){return Object.keys(t).map(function(r){return e.call(n,t[r],r,t)})},Object.values=function(t){return Object.map(t,Function.identity)},Object.concat=function(){for(var t={},e=0;e<arguments.length;e++)Object.addEach(t,arguments[e]);return t},Object.from=Object.concat,Object.is=function(t,e){return t===e?0!==t||1/t===1/e:t!==t&&e!==e},Object.equals=function(t,e,n,o){if(n=n||Object.equals,t=Object.getValueOf(t),e=Object.getValueOf(e),t===e)return!0;if(Object.isObject(t)){if(o=o||new r,o.has(t))return!0;o.set(t,!0)}if(Object.isObject(t)&&"function"==typeof t.equals)return t.equals(e,n,o);if(Object.isObject(e)&&"function"==typeof e.equals)return e.equals(t,n,o);if(Object.isObject(t)&&Object.isObject(e)&&Object.getPrototypeOf(t)===Object.prototype&&Object.getPrototypeOf(e)===Object.prototype){for(var i in t)if(!n(t[i],e[i],n,o))return!1;for(var i in e)if(!(i in t&&n(e[i],t[i],n,o)))return!1;return!0}return t!==t&&e!==e?!0:t&&e?!1:t===e},Object.compare=function(t,e){if(t=Object.getValueOf(t),e=Object.getValueOf(e),t===e)return 0;var n=typeof t,r=typeof e;return"number"===n&&"number"===r?t-e:"string"===n&&"string"===r?e>t?-1/0:1/0:t&&"function"==typeof t.compare?t.compare(e):e&&"function"==typeof e.compare?-e.compare(t):0},Object.clone=function(t,e,n){if(t=Object.getValueOf(t),n=n||new r,void 0===e)e=1/0;else if(0===e)return t;if(Object.isObject(t)){if(!n.has(t))if(t&&"function"==typeof t.clone)n.set(t,t.clone(e,n));else{var o=Object.getPrototypeOf(t);if(null!==o&&o!==Object.prototype)throw new Error("Can't clone "+t);var i=Object.create(o);n.set(t,i);for(var s in t)i[s]=Object.clone(t[s],e-1,n)}return n.get(t)}return t},Object.clear=function(t){if(t&&"function"==typeof t.clear)t.clear();else for(var e=Object.keys(t),n=e.length;n;)n--,delete t[e[n]];return t}}],["collections","shim-regexp",{},function(){if(!RegExp.escape){var t=/[-[\]{}()*+?.\\^$|,#\s]/g;RegExp.escape=function(e){return e.replace(t,"\\$&")}}}],["collections","sorted-array",{"./shim":23,"./generic-collection":5,"./listen/property-changes":16,"./listen/range-changes":17,"sorted-array":28},function(t,e,n){"use strict";function r(t,e,n,o){return this instanceof r?(Array.isArray(t)?(this.array=t,t=t.splice(0,t.length)):this.array=[],this.contentEquals=e||Object.equals,this.contentCompare=n||Object.compare,this.getDefault=o||Function.noop,this.length=0,void this.addEach(t)):new r(t,e,n,o)}function o(t,e,n){for(var r=0,o=t.length-1;o>=r;){var i=r+o>>1,s=n(e,t[i]);if(s>0)r=i+1;else{if(!(0>s))return i;o=i-1}}return-(r+1)}function i(t,e,n,r){var i=o(t,e,n);if(0>i)return-1;for(;i>0&&r(e,t[i-1]);)i--;return r(e,t[i])?i:-1}function s(t,e,n,r){var i=o(t,e,n);if(0>i)return-1;for(;i<t.length-1&&r(e,t[i+1]);)i++;return r(e,t[i])?i:-1}function a(t,e,n){var r=o(t,e,n);if(0>r)return-r-1;for(var i=t.length-1;i>r&&0===n(e,t[r+1]);)r++;return r}n.exports=r;var h=(t("./shim"),t("./generic-collection")),c=t("./listen/property-changes"),p=t("./listen/range-changes");r.SortedArray=r,Object.addEach(r.prototype,h.prototype),Object.addEach(r.prototype,c.prototype),Object.addEach(r.prototype,p.prototype),r.prototype.isSorted=!0,r.prototype.constructClone=function(t){return new this.constructor(t,this.contentEquals,this.contentCompare,this.getDefault)},r.prototype.has=function(t,e){if(e)throw new Error("SortedSet#has does not support second argument: equals");var n=o(this.array,t,this.contentCompare);return n>=0&&this.contentEquals(this.array[n],t)},r.prototype.get=function(t,e){if(e)throw new Error("SortedArray#get does not support second argument: equals");var n=i(this.array,t,this.contentCompare,this.contentEquals);return-1!==n?this.array[n]:this.getDefault(t)},r.prototype.add=function(t){var e=a(this.array,t,this.contentCompare);return this.dispatchesRangeChanges&&this.dispatchBeforeRangeChange([t],[],e),this.array.splice(e,0,t),this.length++,this.dispatchesRangeChanges&&this.dispatchRangeChange([t],[],e),!0},r.prototype["delete"]=function(t,e){if(e)throw new Error("SortedArray#delete does not support second argument: equals");var n=i(this.array,t,this.contentCompare,this.contentEquals);return-1!==n?(this.dispatchesRangeChanges&&this.dispatchBeforeRangeChange([],[t],n),this.array.splice(n,1),this.length--,this.dispatchesRangeChanges&&this.dispatchRangeChange([],[t],n),!0):!1},r.prototype.deleteAll=function(t,e){if(e){var n=this.array.deleteAll(t,e);return this.length-=n,n}var r=i(this.array,t,this.contentCompare,this.contentEquals);if(-1!==r){for(var o=r;this.contentEquals(t,this.array[o]);)o++;var s=this.slice(r,o);return this.dispatchesRangeChanges&&this.dispatchBeforeRangeChange([],s,r),this.array.splice(r,s.length),this.length-=s.length,this.dispatchesRangeChanges&&this.dispatchRangeChange([],s,r),s.length}return 0},r.prototype.indexOf=function(t){return i(this.array,t,this.contentCompare,this.contentEquals)},r.prototype.lastIndexOf=function(t){return s(this.array,t,this.contentCompare,this.contentEquals)},r.prototype.find=function(t,e,n){if(e)throw new Error("SortedArray#find does not support second argument: equals");if(n)throw new Error("SortedArray#find does not support third argument: index");return i(this.array,t,this.contentCompare,this.contentEquals)},r.prototype.findLast=function(t,e,n){if(e)throw new Error("SortedArray#findLast does not support second argument: equals");if(n)throw new Error("SortedArray#findLast does not support third argument: index");return s(this.array,t,this.contentCompare,this.contentEquals)},r.prototype.push=function(){this.addEach(arguments)},r.prototype.unshift=function(){this.addEach(arguments)},r.prototype.pop=function(){var t=this.array.pop();return this.length=this.array.length,t},r.prototype.shift=function(){var t=this.array.shift();return this.length=this.array.length,t},r.prototype.slice=function(){return this.array.slice.apply(this.array,arguments)},r.prototype.splice=function(t,e){return this.swap(t,e,Array.prototype.slice.call(arguments,2))},r.prototype.swap=function(t,e,n){if(void 0===t&&void 0===e)return[];t=t||0,0>t&&(t+=this.length),void 0===e&&(e=1/0);var r=this.slice(t,t+e);return this.dispatchesRangeChanges&&this.dispatchBeforeRangeChange(n,r,t),this.array.splice(t,e),this.addEach(n),this.dispatchesRangeChanges&&this.dispatchRangeChange(n,r,t),r},r.prototype.reduce=function(t,e){var n=arguments[2];return this.array.reduce(function(e,r,o){return t.call(n,e,r,o,this)},e,this)},r.prototype.reduceRight=function(){var t=arguments[2];return this.array.reduceRight(function(e,n,r){return callback.call(t,e,n,r,this)},basis,this)},r.prototype.min=function(){return this.length?this.array[0]:void 0},r.prototype.max=function(){return this.length?this.array[this.length-1]:void 0},r.prototype.one=function(){return this.array.one()},r.prototype.clear=function(){var t;this.dispatchesRangeChanges&&(t=this.array.slice(),this.dispatchBeforeRangeChange([],t,0)),this.length=0,this.array.clear(),this.dispatchesRangeChanges&&this.dispatchRangeChange([],t,0)},r.prototype.equals=function(t,e){return this.array.equals(t,e)},r.prototype.compare=function(t,e){return this.array.compare(t,e)},r.prototype.iterate=function(t,e){return new this.Iterator(this.array,t,e)},r.prototype.toJSON=function(){return this.toArray()},r.prototype.Iterator=Array.prototype.Iterator}],["collections","sorted-array-map",{"./shim":23,"./sorted-array-set":30,"./generic-collection":5,"./generic-map":6,"./listen/property-changes":16,"sorted-array-map":29},function(t,e,n){"use strict";function r(t,e,n,i){return this instanceof r?(e=e||Object.equals,n=n||Object.compare,i=i||Function.noop,this.contentEquals=e,this.contentCompare=n,this.getDefault=i,this.store=new o(null,function(t,n){return e(t.key,n.key)},function(t,e){return n(t.key,e.key)}),this.length=0,void this.addEach(t)):new r(t,e,n,i)}var o=(t("./shim"),t("./sorted-array-set")),i=t("./generic-collection"),s=t("./generic-map"),a=t("./listen/property-changes");n.exports=r,r.SortedArrayMap=r,Object.addEach(r.prototype,i.prototype),Object.addEach(r.prototype,s.prototype),Object.addEach(r.prototype,a.prototype),r.prototype.isSorted=!0,r.prototype.constructClone=function(t){return new this.constructor(t,this.contentEquals,this.contentCompare,this.getDefault)}}],["collections","sorted-array-set",{"./shim":23,"./sorted-array":28,"./generic-set":8,"./listen/property-changes":16},function(t,e,n){"use strict";function r(t,e,n,i){return this instanceof r?void o.call(this,t,e,n,i):new r(t,e,n,i)}n.exports=r;var o=(t("./shim"),t("./sorted-array")),i=t("./generic-set"),s=t("./listen/property-changes");r.SortedArraySet=r,r.prototype=Object.create(o.prototype),r.prototype.constructor=r,Object.addEach(r.prototype,i.prototype),Object.addEach(r.prototype,s.prototype),r.prototype.isSorted=!0,r.prototype.add=function(t){return this.has(t)?!1:(o.prototype.add.call(this,t),!0)},r.prototype.reduce=function(t,e){var n=this,r=arguments[2];return this.array.reduce(function(e,o,i){return t.call(r,e,o,i,n)},e)},r.prototype.reduceRight=function(t,e){var n=this,r=arguments[2];return this.array.reduceRight(function(e,o,i){return t.call(r,e,o,i,n)},e)}}],["collections","sorted-map",{"./shim":23,"./sorted-set":32,"./generic-collection":5,"./generic-map":6,"./listen/property-changes":16,"sorted-map":31},function(t,e,n){"use strict";function r(t,e,n,i){return this instanceof r?(e=e||Object.equals,n=n||Object.compare,i=i||Function.noop,this.contentEquals=e,this.contentCompare=n,this.getDefault=i,this.store=new o(null,function(t,n){return e(t.key,n.key)},function(t,e){return n(t.key,e.key)}),this.length=0,void this.addEach(t)):new r(t,e,n,i)}var o=(t("./shim"),t("./sorted-set")),i=t("./generic-collection"),s=t("./generic-map"),a=t("./listen/property-changes");n.exports=r,r.SortedMap=r,Object.addEach(r.prototype,i.prototype),Object.addEach(r.prototype,s.prototype),Object.addEach(r.prototype,a.prototype),r.prototype.constructClone=function(t){return new this.constructor(t,this.contentEquals,this.contentCompare,this.getDefault)},r.prototype.log=function(t,e,n,r){e=e||this.logNode,this.store.log(t,function(t,n,r){e(t.value,n,r)},n,r)},r.prototype.logNode=function(t,e){e(" key: "+t.key),e(" value: "+t.value)}}],["collections","sorted-set",{"./shim":23,"./generic-collection":5,"./generic-set":8,"./listen/property-changes":16,"./listen/range-changes":17,"./tree-log":33,"sorted-set":32},function(t,e,n){"use strict";function r(t,e,n,o){return this instanceof r?(this.contentEquals=e||Object.equals,this.contentCompare=n||Object.compare,this.getDefault=o||Function.noop,this.root=null,this.length=0,void this.addEach(t)):new r(t,e,n,o)}function o(t){this.value=t,this.left=null,this.right=null,this.length=1}function i(t,e,n){if(this.set=t,this.prev=null,this.end=n,e){var r=this.set.findLeastGreaterThanOrEqual(e);r&&(this.set.splay(r.value),this.prev=r.getPrevious())}}n.exports=r;var s=(t("./shim"),t("./generic-collection")),a=t("./generic-set"),h=t("./listen/property-changes"),c=t("./listen/range-changes"),p=t("./tree-log");r.SortedSet=r,Object.addEach(r.prototype,s.prototype),Object.addEach(r.prototype,a.prototype),Object.addEach(r.prototype,h.prototype),Object.addEach(r.prototype,c.prototype),r.prototype.isSorted=!0,r.prototype.constructClone=function(t){return new this.constructor(t,this.contentEquals,this.contentCompare,this.getDefault)},r.prototype.has=function(t,e){if(e)throw new Error("SortedSet#has does not support second argument: equals");return this.root?(this.splay(t),this.contentEquals(t,this.root.value)):!1},r.prototype.get=function(t,e){if(e)throw new Error("SortedSet#get does not support second argument: equals");return this.root&&(this.splay(t),this.contentEquals(t,this.root.value))?this.root.value:this.getDefault(t)},r.prototype.add=function(t){var e=new this.Node(t);if(!this.root)return this.dispatchesRangeChanges&&this.dispatchBeforeRangeChange([t],[],0),this.root=e,this.length++,this.dispatchesRangeChanges&&this.dispatchRangeChange([t],[],0),!0;if(this.splay(t),!this.contentEquals(t,this.root.value)){var n=this.contentCompare(t,this.root.value);if(0===n)throw new Error("SortedSet cannot contain incomparable but inequal values: "+t+" and "+this.root.value);return this.dispatchesRangeChanges&&this.dispatchBeforeRangeChange([t],[],this.root.index),0>n?(e.right=this.root,e.left=this.root.left,this.root.left=null,this.root.touch()):(e.left=this.root,e.right=this.root.right,this.root.right=null,this.root.touch()),e.touch(),this.root=e,this.length++,this.dispatchesRangeChanges&&this.dispatchRangeChange([t],[],this.root.index),!0}return!1},r.prototype["delete"]=function(t,e){if(e)throw new Error("SortedSet#delete does not support second argument: equals");if(this.root&&(this.splay(t),this.contentEquals(t,this.root.value))){var n=this.root.index;if(this.dispatchesRangeChanges&&this.dispatchBeforeRangeChange([],[t],n),this.root.left){var r=this.root.right;this.root=this.root.left,this.splay(t),this.root.right=r}else this.root=this.root.right;return this.length--,this.root&&this.root.touch(),this.dispatchesRangeChanges&&this.dispatchRangeChange([],[t],n),!0}return!1},r.prototype.indexOf=function(t,e){if(e)throw new Error("SortedSet#indexOf does not support second argument: startIndex");return this.root&&(this.splay(t),this.contentEquals(t,this.root.value))?this.root.index:-1},r.prototype.find=function(t,e,n){if(e)throw new Error("SortedSet#find does not support second argument: equals");if(n)throw new Error("SortedSet#find does not support third argument: index");return this.root&&(this.splay(t),this.contentEquals(t,this.root.value))?this.root:void 0},r.prototype.findGreatest=function(t){if(this.root){for(t=t||this.root;t.right;)t=t.right;return t}},r.prototype.findLeast=function(t){if(this.root){for(t=t||this.root;t.left;)t=t.left;return t}},r.prototype.findGreatestLessThanOrEqual=function(t){return this.root?(this.splay(t),this.contentCompare(this.root.value,t)>0?this.root.getPrevious():this.root):void 0},r.prototype.findGreatestLessThan=function(t){return this.root?(this.splay(t),this.contentCompare(this.root.value,t)>=0?this.root.getPrevious():this.root):void 0},r.prototype.findLeastGreaterThanOrEqual=function(t){return this.root?(this.splay(t),this.contentCompare(this.root.value,t)>=0?this.root:this.root.getNext()):void 0},r.prototype.findLeastGreaterThan=function(t){return this.root?(this.splay(t),this.contentCompare(this.root.value,t)<=0?this.root.getNext():this.root):void 0},r.prototype.pop=function(){if(this.root){var t=this.findGreatest();return this["delete"](t.value),t.value}},r.prototype.shift=function(){if(this.root){var t=this.findLeast();return this["delete"](t.value),t.value}},r.prototype.push=function(){this.addEach(arguments)},r.prototype.unshift=function(){this.addEach(arguments)},r.prototype.slice=function(t,e){t=t||0,e=e||this.length,0>t&&(t+=this.length),0>e&&(e+=this.length);var n=[];if(this.root)for(this.splayIndex(t);this.root.index<e&&(n.push(this.root.value),this.root.right);)this.splay(this.root.getNext().value);return n},r.prototype.splice=function(t,e){return this.swap(t,e,Array.prototype.slice.call(arguments,2))},r.prototype.swap=function(t,e,n){if(void 0===t&&void 0===e)return[];t=t||0,0>t&&(t+=this.length),void 0===e&&(e=1/0);var r=[];if(this.root){this.splayIndex(t);for(var o=0;e>o;o++){r.push(this.root.value);var i=this.root.getNext();if(this["delete"](this.root.value),!i)break;this.splay(i.value)}}return this.addEach(n),r},r.prototype.splay=function(t){var e,n,r,i,s,a;if(this.root){for(e=n=r=new this.Node,a=new this.Node,s=this.root;;){var h=this.contentCompare(t,s.value);if(0>h){if(!s.left)break;if(this.contentCompare(t,s.left.value)<0&&(i=s.left,s.left=i.right,s.touch(),i.right=s,i.touch(),s=i,!s.left))break;i=new o,i.right=s,i.left=a.left,a.left=i,r.left=s,r.touch(),r=s,s=s.left}else{if(!(h>0))break;if(!s.right)break;if(this.contentCompare(t,s.right.value)>0&&(i=s.right,s.right=i.left,s.touch(),i.left=s,i.touch(),s=i,!s.right))break;i=new o,i.left=s,i.right=a.right,a.right=i,n.right=s,n.touch(),n=s,s=s.right}}for(n.right=s.left,n.touch(),r.left=s.right,r.touch(),s.left=e.right,s.right=e.left;a.left;)a.left.right.touch(),a.left=a.left.left;for(;a.right;)a.right.left.touch(),a.right=a.right.right;s.touch(),this.root=s}},r.prototype.splayIndex=function(t){if(this.root){for(var e=this.root,n=this.root.index;n!==t;)if(n>t&&e.left)e=e.left,n-=1+(e.right?e.right.length:0);else{if(!(t>n&&e.right))break;e=e.right,n+=1+(e.left?e.left.length:0)}return this.splay(e.value),this.root.index===t}return!1},r.prototype.reduce=function(t,e,n){return this.root&&(e=this.root.reduce(t,e,0,n,this)),e},r.prototype.reduceRight=function(t,e,n){return this.root&&(e=this.root.reduceRight(t,e,this.length-1,n,this)),e},r.prototype.min=function(t){var e=this.findLeast(t);return e?e.value:void 0},r.prototype.max=function(t){var e=this.findGreatest(t);return e?e.value:void 0},r.prototype.one=function(){return this.min()},r.prototype.clear=function(){var t;this.dispatchesRangeChanges&&(t=this.toArray(),this.dispatchBeforeRangeChange([],t,0)),this.root=null,this.length=0,this.dispatchesRangeChanges&&this.dispatchRangeChange([],t,0)},r.prototype.iterate=function(t,e){return new this.Iterator(this,t,e)},r.prototype.Iterator=i,r.prototype.summary=function(){return this.root?this.root.summary():"()"},r.prototype.log=function(t,e,n,r){t=t||p.unicodeRound,e=e||this.logNode,n||(n=console.log,r=console),n=n.bind(r),this.root&&this.root.log(t,e,n,n)},r.prototype.logNode=function(t,e){e(" "+t.value)},r.logCharsets=p,r.prototype.Node=o,o.prototype.reduce=function(t,e,n,r,o,i){if(i=i||0,this.left){var s=this.left.length;e=this.left.reduce(t,e,n,r,o,i+1),n+=s}return e=t.call(r,e,this.value,n,o,this,i),n+=1,this.right&&(e=this.right.reduce(t,e,n,r,o,i+1)),e},o.prototype.reduceRight=function(t,e,n,r,o,i){return i=i||0,this.right&&(e=this.right.reduce(t,e,n,r,o,i+1),n-=this.right.length),e=t.call(r,e,this.value,this.value,o,this,i),n-=1,this.left&&(e=this.left.reduce(t,e,n,r,o,i+1)),e},o.prototype.touch=function(){this.length=1+(this.left?this.left.length:0)+(this.right?this.right.length:0),this.index=this.left?this.left.length:0},o.prototype.checkIntegrity=function(){var t=1;if(t+=this.left?this.left.checkIntegrity():0,t+=this.right?this.right.checkIntegrity():0,this.length!==t)throw new Error("Integrity check failed: "+this.summary());return t},o.prototype.getNext=function(){var t=this;if(t.right){for(t=t.right;t.left;)t=t.left;return t}},o.prototype.getPrevious=function(){var t=this;if(t.left){for(t=t.left;t.right;)t=t.right;return t}},o.prototype.summary=function(){var t=this.value||"-";return t+=" <"+this.length,this.left||this.right?"("+t+" "+(this.left?this.left.summary():"()")+", "+(this.right?this.right.summary():"()")+")":"("+t+")"},o.prototype.log=function(t,e,n,r){var o,i=this;o=this.left&&this.right?t.intersection:this.left?t.branchUp:this.right?t.branchDown:t.through;var s;this.left&&this.left.log(t,e,function(e){s?r(t.strafe+" "+e):(s=!0,r(t.fromBelow+t.through+e))},function(t){r("  "+t)});var a;e(this,function(e){a?n((i.right?t.strafe:" ")+e):(a=!0,n(o+e))},function(e){r((i.left?t.strafe:" ")+e)});var h;this.right&&this.right.log(t,e,function(e){h?n("  "+e):(h=!0,n(t.fromAbove+t.through+e))},function(e){n(t.strafe+" "+e)})},i.prototype.next=function(){var t;if(t=this.prev?this.set.findLeastGreaterThan(this.prev.value):this.set.findLeast(),!t)throw StopIteration;if(void 0!==this.end&&this.set.contentCompare(t.value,this.end)>=0)throw StopIteration;return this.prev=t,t.value}}],["collections","tree-log",{},function(t,e,n){"use strict";function r(){}n.exports=r,r.ascii={intersection:"+",through:"-",branchUp:"+",branchDown:"+",fromBelow:".",fromAbove:"'",fromBoth:"+",strafe:"|"},r.unicodeRound={intersection:"╋",through:"━",branchUp:"┻",branchDown:"┳",fromBelow:"╭",fromAbove:"╰",fromBoth:"┣",strafe:"┃"},r.unicodeSharp={intersection:"╋",through:"━",branchUp:"┻",branchDown:"┳",fromBelow:"┏",fromAbove:"┗",fromBoth:"┣",strafe:"┃"}}],["collections-website","lib/repl",{},function(t,e,n){function r(t){return function(){for(var e="",n=0;n<arguments.length;n++)"string"==typeof arguments[n]?(n>0&&(e+=" "),e+=arguments[n]):e+=s(arguments[n])+" ";var r=h(e,"log");r&&t.appendChild(r)}}function o(t,e){for(var n=t.querySelectorAll(".repl-input"),r=0;r<n.length;r++)t.removeChild(n[r]);for(r=0;r<n.length;r++){var o=n[r];t.appendChild(o);var s=h(i(o.textContent,e));s&&t.appendChild(s)}}function i(t,e){var n;window.__replContext__=e;var r="with(window.__replContext__){\n"+t+"\n}";try{n=p(r),e._=e.$_=n,n=s(n)}catch(o){n=o.name+": "+o.message}return delete window.__replContext__,n}function s(t){var e;if("function"==typeof t)e=t.toString();else try{e=JSON.stringify(t)}catch(n){e="<Unable to stringify "+t.toString()+">"}return e}function a(t){var e=document.createElement("span");return e.classList.add("repl-input"),e.textContent=t+"\n",e}function h(t,e){if(e=e||"output","undefined"!=typeof t){var n=document.createElement("span");n.classList.add("repl-"+e),n.textContent=t+"\n";var r=document.createElement("span");return r.classList.add("repl-output-comment"),r.textContent="// ",n.insertBefore(r,n.lastChild),n}}function c(t,e,n){var r=document.createElement("div");r.classList.add("repl-command");var o=document.createElement("input");o.addEventListener("keyup",function(t){if(13===t.keyCode&&this.value){var r=a(this.value);e.appendChild(r);var o=h(i(this.value,n));o&&e.appendChild(o),this.value="",this.scrollIntoViewIfNeeded?this.scrollIntoViewIfNeeded():this.scrollIntoView&&this.scrollIntoView(),ga&&ga("send","event","repl","input")}}),r.appendChild(o),t.appendChild(r)}var p=eval;n.exports=function(t){var e=t.children[0],n={console:{log:r(e)}};o(e,n),c(t,e,n)}}],["collections-website","lib/track-errors",{},function(){window.onerror=function(t,e,n){ga&&ga("send","event","global","error",t+" in "+e+" line "+n)}}],["weak-map","weak-map",{},function(t,e,n){!function(){"use strict";function t(e){e.permitHostObjects___&&e.permitHostObjects___(t)}function e(t){return!(t.substr(0,c.length)==c&&"___"===t.substr(t.length-3))}function r(t){if(t!==Object(t))throw new TypeError("Not an object: "+t);var e=t[p];if(e&&e.key===t)return e;if(!h(t))return void 0;var n=[],r=[];return e={key:t,gets:n,vals:r},a(t,p,{value:e,writable:!1,enumerable:!1,configurable:!1}),e}function o(t){return t.prototype=null,Object.freeze(t)}if("undefined"==typeof ses||!ses.ok||ses.ok()){if("undefined"!=typeof ses&&(ses.weakMapPermitHostObjects=t),"function"==typeof WeakMap){var i=WeakMap;if("undefined"==typeof navigator||!/Firefox/.test(navigator.userAgent))return void(n.exports=WeakMap)}var s=(Object.prototype.hasOwnProperty,Object.getOwnPropertyNames),a=Object.defineProperty,h=Object.isExtensible,c="weakmap:",p=c+"ident:"+Math.random()+"___";if("undefined"!=typeof crypto&&"function"==typeof crypto.getRandomValues&&"function"==typeof ArrayBuffer&&"function"==typeof Uint8Array){var u=new ArrayBuffer(25),l=new Uint8Array(u);crypto.getRandomValues(l),p=c+"rand:"+Array.prototype.map.call(l,function(t){return(t%36).toString(36)}).join("")+"___"}if(a(Object,"getOwnPropertyNames",{value:function(t){return s(t).filter(e)}}),"getPropertyNames"in Object){var f=Object.getPropertyNames;a(Object,"getPropertyNames",{value:function(t){return f(t).filter(e)}})}!function(){var t=Object.freeze;a(Object,"freeze",{value:function(e){return r(e),t(e)}});var e=Object.seal;a(Object,"seal",{value:function(t){return r(t),e(t)}});var n=Object.preventExtensions;a(Object,"preventExtensions",{value:function(t){return r(t),n(t)}})}();var g=function(){function t(e,n){var o,i,h=r(e);return h?(o=h.gets.indexOf(t),i=h.vals):(o=s.indexOf(e),i=a),o>=0?i[o]:n}function e(e){var n,o=r(e);return n=o?o.gets.indexOf(t):s.indexOf(e),n>=0}function n(e,n){var o,i=r(e);i?(o=i.gets.indexOf(t),o>=0?i.vals[o]=n:(i.gets.push(t),i.vals.push(n))):(o=s.indexOf(e),o>=0?a[o]=n:(s.push(e),a.push(n)))}function i(e){var n,o=r(e);return o?(n=o.gets.indexOf(t),n>=0&&(o.gets.splice(n,1),o.vals.splice(n,1))):(n=s.indexOf(e),n>=0&&(s.splice(n,1),a.splice(n,1))),!0}var s=[],a=[];return Object.create(g.prototype,{get___:{value:o(t)},has___:{value:o(e)},set___:{value:o(n)},delete___:{value:o(i)}})};g.prototype=Object.create(Object.prototype,{get:{value:function(t,e){return this.get___(t,e)},writable:!0,configurable:!0},has:{value:function(t){return this.has___(t)},writable:!0,configurable:!0},set:{value:function(t,e){this.set___(t,e)},writable:!0,configurable:!0},"delete":{value:function(t){return this.delete___(t)},writable:!0,configurable:!0}}),"function"==typeof i?!function(){function e(){function e(t,e){return h?a.has(t)?a.get(t):h.get___(t,e):a.get(t,e)}function n(t){return a.has(t)||(h?h.has___(t):!1)}function r(t,e){if(c)try{a.set(t,e)}catch(n){h||(h=new g),h.set___(t,e)}else a.set(t,e)}function s(t){a["delete"](t),h&&h.delete___(t)}var a=new i,h=void 0,c=!1;return Object.create(g.prototype,{get___:{value:o(e)},has___:{value:o(n)},set___:{value:o(r)},delete___:{value:o(s)},permitHostObjects___:{value:o(function(e){if(e!==t)throw new Error("bogus call to permitHostObjects___");c=!0})}})}e.prototype=g.prototype,n.exports=e,Object.defineProperty(WeakMap.prototype,"constructor",{value:WeakMap,enumerable:!1,configurable:!0,writable:!0})}():("undefined"!=typeof Proxy&&(Proxy=void 0),n.exports=g)}}()}]]}(this));
